' NOTE:  Not all constant values are imported for this instrument driver.
' Refer to nifgen.h for the full set of constant values for properties and parameters.


'------------------------------------------------------------------------------
' <autogenerated>
'     This code was generated by Measurement Studio.
'     Runtime Version: 1.1.4322.2032
'
'     Changes to this file may cause incorrect behavior and will be lost if 
'     the code is regenerated.
' </autogenerated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace InstrumentDriverInterop.Ivi

Public Class niFgen
    Inherits Object
    Implements System.IDisposable
    
    Private _handle As System.IntPtr
    
    Private _disposed As Boolean = true
    
    '''<summary>
    '''Performs the following initialization actions:
    '''
    '''- Creates a new IVI instrument driver session.
    '''- Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
    '''- If the IDQuery parameter is set to VI_TRUE, this function queries the device ID and checks that the ID is valid for NI-FGEN.
    '''- If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
    '''- Sends initialization commands to set the device to the state necessary for the operation of NI-FGEN.
    '''- Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource Name specifies the resource name of the device to initialize.
    ''' 
    '''Examples 
    '''-----------------------------------------------------------
    '''DAQ::1              Traditional NI-DAQ device, 
    '''                    device number = 1
    '''DAQ::2              NI-DAQmx device, device name = "2"
    '''myDAQmxDevice       NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''myLogicalName       IVI logical name or virtual instrument, 
    '''                    name = "myLogicalName"
    '''
    '''For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
    ''' 
    '''For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
    ''' 
    '''An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
    '''
    '''If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
    '''
    '''You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
    '''
    '''</param>
    '''<param name="ID_Query">
    '''Specify whether you want NI-FGEN to perform an ID query.
    '''
    '''When you set this parameter to VI_TRUE, NI-FGEN verifies that the device you initialize is a type that it supports.  
    '''
    '''Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Perform ID Query
    '''VI_FALSE - Skip ID Query
    '''
    '''Default Value: VI_TRUE
    '''</param>
    '''<param name="Reset_Device">
    '''Specify whether you want to reset the device during the initialization procedure.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Reset Device 
    '''VI_FALSE - Do Not Reset Device
    '''
    '''Default Value: VI_TRUE
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Performs the following initialization actions:
    '''
    '''- Creates a new IVI instrument session and optionally sets the initial state of the following session attributes: RangeCheck, Cache, Simulate, and RecordCoersions.         
    '''- Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
    '''- If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
    '''- Sends initialization commands to set the instrument to the state necessary for NI-FGEN operation.
    '''- Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource Name specifies the resource name of the device to initialize.
    ''' 
    '''Examples 
    '''-----------------------------------------------------------
    '''DAQ::1              Traditional NI-DAQ device, 
    '''                    device number = 1
    '''DAQ::2              NI-DAQmx device, device name = "2"
    '''myDAQmxDevice       NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''myLogicalName       IVI logical name or virtual instrument, 
    '''                    name = "myLogicalName"
    '''
    '''For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
    ''' 
    '''For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
    ''' 
    '''An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
    '''
    '''If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
    '''
    '''You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
    '''
    '''</param>
    '''<param name="ID_Query">
    '''Specify whether you want NI-FGEN to perform an ID query.
    '''
    '''When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is a type that it supports.  
    '''
    '''Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Perform ID Query
    '''VI_FALSE - Skip ID Query
    '''
    '''Default Value: VI_TRUE
    '''
    '''
    '''</param>
    '''<param name="Reset_Device">
    '''Specify whether you want to reset the device during the initialization procedure.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Reset Device
    '''VI_FALSE - Do not Reset
    '''
    '''Default Value: VI_TRUE
    '''</param>
    '''<param name="Option_String">
    '''You can use this parameter to set the initial value of certain session attributes. 
    '''
    '''The syntax for Option String is 
    '''
    '''   &lt;attributeName&gt;=&lt;value&gt;
    '''
    '''where
    '''
    '''   attributeName = the name of the attribute
    '''   value = the value to which the attribute is set. 
    '''
    '''To set multiple attributes, separate them with a comma.  
    '''
    '''If you pass NULL or an empty string for this parameter, the session uses the default values for these attributes. You can override the default values by assigning a value explicitly in a string that you pass for this parameter. 
    '''
    '''You do not have to specify all of the attributes and may leave any of them out. However, if you do not specify one of the attributes, its default value is used.  
    '''
    '''If simulation is enabled (Simulate=1), you may specify the device that you want to simulate. To specify a device, enter the following syntax in Option String.
    '''
    '''DriverSetup=Model:&lt;driver model number&gt;;BoardType:&lt;module type&gt;;MemorySize:&lt;size of onboard memory in bytes&gt;
    '''
    '''Examples
    '''
    '''Device      Option String Syntax 
    '''------------------------------------------------
    '''NI PXI-5404 DriverSetup=Model:5404;BoardType:PXI
    '''NI PCI-5411 DriverSetup=Model:5411;BoardType:
    '''            PCI;MemorySize:8000000
    '''
    '''Attributes and Defined Values
    '''
    '''Attribute Name    Attribute                 Values
    '''--------------------------------------------------------------
    '''RangeCheck        NIFGEN_ATTR_RANGE_CHECK   VI_TRUE, VI_FALSE
    '''Cache             NIFGEN_ATTR_CACHE         VI_TRUE, VI_FALSE
    '''Simulate          NIFGEN_ATTR_SIMULATE      VI_TRUE, VI_FALSE
    '''
    '''Default Values: "Simulate=0,RangeCheck=1,Cache=1"
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Option_String As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Creates and initializes a special FGEN external calibration session.  The ViSession returned is an FGEN session that can be used to configure the device using normal attributes and functions.  However, flags have been set that allow the user to program an external calibration procedure using the special calibration attributes and functions.
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource Name specifies the resource name of the device to initialize.
    ''' 
    '''Examples 
    '''-----------------------------------------------------------
    '''DAQ::1              Traditional NI-DAQ device, 
    '''                    device number = 1
    '''DAQ::2              NI-DAQmx device, device name = "2"
    '''myDAQmxDevice       NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''DAQ::myDAQmxDevice  NI-DAQmx device, device name = 
    '''                    "myDAQmxDevice"
    '''myLogicalName       IVI logical name or virtual instrument, 
    '''                    name = "myLogicalName"
    '''
    '''For Traditional NI-DAQ devices, the syntax is "DAQ::n", where n is the device number assigned by MAX.
    ''' 
    '''For NI-DAQmx devices, the syntax is just the device name specified in MAX. Typical default names for NI-DAQmx devices in MAX are "Dev1" or "PXI1Slot1". You can rename an NI-DAQmx device by right clicking on the name in MAX and entering a new name.
    ''' 
    '''An alternate syntax is allowed for NI-DAQmx devices, which consists of "DAQ::" followed by the NI-DAQmx device name. This naming convention allows using an NI-DAQmx device in an application that may have originally been designed for a Traditional NI-DAQ device. For example, if the application expects "DAQ::1", you can rename the device to "1" in MAX and pass in "DAQ::1" for the resource name. 
    '''
    '''If you use the "DAQ::n" syntax and an NI-DAQmx device name already exists with the same name, the NI-DAQmx device will be matched first. 
    '''
    '''You can also pass in the name of a virtual instrument or logical name that you configure with the IVI Configuration utility. The virtual instrument identifies a specific device and specifies the initial settings for the session. A logical name identifies a particular virtual instrument. 
    '''
    '''</param>
    '''<param name="Password">
    '''The calibration password required to open an external calibration session to the device.
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a session handle that you use to identify the instrument in all subsequent NI-FGEN function calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal Password As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitExtCal(Resource_Name, Password, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Causes a transition to the Committed state. This function verifies attribute values, reserves the device, and commits the attribute values to the device. If the attributes values are all valid, the device configuration matches the session configuration.
    '''
    '''In the Committed state, waveforms, scripts, and sequences can be loaded into memory. If any attributes are changed, NI-FGEN implicitly transitions back to the Idle state. This function has no effect if the device is already in the Committed or Generating states, and returns a successful status value.
    '''
    '''Some benefits of this function are as follows:
    '''
    '''- niFgen_InitiateGeneration occurs faster because the device 
    '''  is configured.
    '''- Routes are committed, so signals are exported or imported.
    '''- The PLL and all DCMs are locked.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''</returns>
    Public Function Commit() As Integer
        Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Resets the instrument to a known state. 
    '''
    '''Note: For the NI 5421, this function aborts the generation, clears all routes, and resets session attributes to the default values. This function does not, however, commit the session attributes or configure the device to its default state.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function reset() As Integer
        Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Determines how the signal generator produces waveforms.  NI signal generators currently support only one value:  continuous.  To control trigger mode, use niFgen_ConfigureTriggerMode instead.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Operation_Mode">
    '''Pass the operation mode you want the signal generator to use.  NI-FGEN sets NIFGEN_ATTR_OPERATION_MODE to this value.  
    '''
    '''Only one value, NIFGEN_VAL_OPERATE_CONTINUOUS, is currently valid.  A second value, NIFGEN_VAL_OPERATE_BURST, is listed for IVI compatibility but is not supported by NI signal generators.  To control trigger mode on NI signal generators, use niFgen_ConfigureTriggerMode instead.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_OPERATE_CONTINUOUS
    '''NIFGEN_VAL_OPERATE_BURST
    '''
    '''Default Value: NIFGEN_VAL_OPERATE_CONTINUOUS
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes:
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureOperationMode(ByVal Channel_Name As String, ByVal Operation_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOperationMode(Me._handle, Channel_Name, Operation_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the output mode of the signal generator. The output mode determines how the signal generator produces waveforms.
    '''
    '''For example, you can select to output a standard waveform, an arbitrary waveform, or a sequence of arbitrary waveforms.  
    '''
    '''Note: The signal generator must not be in the Generating state when you call this function.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Output_Mode">
    '''Pass the output mode that you want the signal generator to use. NI-FGEN sets NIFGEN_ATTR_OUTPUT_MODE to this value. The value you specify determines which functions and attributes you can use to configure the waveform the signal generator produces.
    '''
    '''When you set output mode to NIFGEN_VAL_OUTPUT_FUNC, you can use the following functions to configure the waveform:
    '''
    '''- niFgen_ConfigureStandardWaveform
    '''- niFgen_DefineUserStandardWaveform
    '''- niFgen_ClearUserStandardWaveform
    '''- niFgen_ConfigureFrequency
    '''- niFgen_ConfigureAmplitude
    '''
    '''You can also set the following attributes:
    '''
    '''- NIFGEN_ATTR_FUNC_WAVEFORM     
    '''- NIFGEN_ATTR_FUNC_AMPLITUDE 
    '''- NIFGEN_ATTR_FUNC_DC_OFFSET   
    '''- NIFGEN_ATTR_FUNC_FREQUENCY 
    '''- NIFGEN_ATTR_FUNC_START_PHASE   
    '''- NIFGEN_ATTR_FUNC_DUTY_CYCLE_HIGH
    '''
    '''When you set Output Mode to NIFGEN_VAL_OUTPUT_FREQ_LIST, you can use the following functions to configure the waveform:
    '''
    '''- niFgen_CreateFreqList
    '''- niFgen_ClearFreqList
    '''- niFgen_QueryFreqListCapabilities
    '''- niFgen_ConfigureFreqList
    '''- niFgen_ConfigureAmplitude
    '''
    '''You can also set the following attributes:
    '''
    '''- NIFGEN_ATTR_FREQ_LIST_HANDLE
    '''- NIFGEN_ATTR_FUNC_AMPLITUDE
    '''- NIFGEN_ATTR_FUNC_DC_OFFSET
    '''- NIFGEN_ATTR_FUNC_START_PHASE
    '''
    '''When you set Output Mode to NIFGEN_VAL_OUTPUT_ARB, you can use the following functions to configure the waveform:
    '''
    '''- niFgen_QueryArbWfmCapabilities
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''- niFgen_CreateBin16ArbWaveform
    '''- niFgen_ClearArbWaveform
    '''- niFgen_ClearArbMemory
    '''- niFgen_ConfigureSampleRate
    '''- niFgen_ConfigureGain
    '''- niFgen_ConfigureArbWaveform
    '''- niFgen_ConfigureClockMode 
    '''
    '''You can also set the following attributes:
    '''
    '''- NIFGEN_ATTR_ARB_WAVEFORM_HANDLE  
    '''- NIFGEN_ATTR_ARB_GAIN
    '''- NIFGEN_ATTR_ARB_OFFSET  
    '''- NIFGEN_ATTR_ARB_SAMPLE_RATE 
    '''- NIFGEN_ATTR_CLOCK_MODE
    '''
    '''When you set Output Mode to NIFGEN_VAL_OUTPUT_SEQ, you can use the following functions to configure the sequence:
    '''
    '''- niFgen_QueryArbWfmCapabilities 
    '''- niFgen_AllocateWaveform 
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS 
    '''- niFgen_SetWaveformNextWritePosition 
    '''- niFgen_WriteWaveform 
    '''- niFgen_WriteBinary16Waveform 
    '''- niFgen_ClearArbWaveform 
    '''- niFgen_ClearArbMemory 
    '''- niFgen_QueryArbSeqCapabilities 
    '''- niFgen_CreateArbSequence 
    '''- niFgen_CreateAdvancedArbSequence 
    '''- niFgen_ClearArbSequence 
    '''- niFgen_ConfigureSampleRate 
    '''- niFgen_ConfigureClockMode 
    '''- niFgen_ConfigureArbSequence 
    '''
    '''
    '''You can also set the following attributes:
    '''
    '''- NIFGEN_ATTR_ARB_SEQUENCE_HANDLE  
    '''- NIFGEN_ATTR_ARB_GAIN
    '''- NIFGEN_ATTR_ARB_OFFSET  
    '''- NIFGEN_ATTR_ARB_SAMPLE_RATE 
    '''- NIFGEN_ATTR_CLOCK_MODE
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_OUTPUT_FUNC
    '''NIFGEN_VAL_OUTPUT_FREQ_LIST
    '''NIFGEN_VAL_OUTPUT_ARB
    '''NIFGEN_VAL_OUTPUT_SEQ
    ''' 
    '''Default Value: NIFGEN_VAL_OUTPUT_FUNC
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureOutputMode(ByVal Output_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputMode(Me._handle, Output_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Enables or disables the signal generator output.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to enable or disable the output.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Enabled">
    '''Pass whether you want to enable or disable the output. NI-FGEN uses this value to set NIFGEN_ATTR_OUTPUT_ENABLED.
    '''
    '''Defined Value
    '''
    '''VI_TRUE  - Enable the output 
    '''VI_FALSE - Disable the output
    '''
    '''Default Value: VI_TRUE
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''This driver defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureOutputEnabled(ByVal Channel_Name As String, ByVal Enabled As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputEnabled(Me._handle, Channel_Name, System.Convert.ToUInt16(Enabled))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the output impedance for the channel you specify.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to set the output impedance.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Impedance">
    '''Pass the impedance value that you want the signal generator to use.  NI-FGEN sets NIFGEN_ATTR_OUTPUT_IMPEDANCE to this value. 
    '''
    '''Units: ohms
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_50_OHMS
    '''NIFGEN_VAL_75_OHMS
    '''
    '''Default Value: NIFGEN_VAL_50_OHMS
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''aNI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureOutputImpedance(ByVal Channel_Name As String, ByVal Impedance As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputImpedance(Me._handle, Channel_Name, Impedance)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Enables the analog filter. You can also specify the filter correction frequency of the analog filter. This sets NIFGEN_ATTR_ANALOG_FILTER_ENABLED to VI_TRUE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to enable the analog filter.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Filter_Correction_Frequency">
    '''Specifies the filter correction frequency of the analog filter. On the NI 5411 and NI 5431, NI-FGEN adjusts signal amplitude to compensate for the filter's attenuation at that frequency. To disable amplitude correction, set Filter_Correction_Frequency to 0. For Standard Waveform Output, the filter correction frequency should typically be set to be the same as the frequency of the standard waveform.
    '''
    '''Units: Hz
    '''
    '''Default Value: 0
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function EnableAnalogFilter(ByVal Channel_Name As String, ByVal Filter_Correction_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableAnalogFilter(Me._handle, Channel_Name, Filter_Correction_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Disables the analog filter. This paramenter sets NIFGEN_ATTR_ANALOG_FILTER_ENABLED to VI_FALSE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to disable the analog filter.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function DisableAnalogFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableAnalogFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Enables the digital filter by setting NIFGEN_ATTR_DIGITAL_FILTER_ENABLED to VI_TRUE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to enable the digital filter.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function EnableDigitalFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableDigitalFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Disables the digital filter. This sets the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_FALSE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to disable the digital filter.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function DisableDigitalFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableDigitalFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Enables digital patterning on the signal generator. This sets NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED to VI_TRUE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to enable the digital pattern output.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function EnableDigitalPatterning(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableDigitalPatterning(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Disables digital patterning on the signal generator. This sets NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED to VI_FALSE.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to disable the digital pattern output.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function DisableDigitalPatterning(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableDigitalPatterning(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the attributes of the signal generator that affect standard waveform generation. These attributes are the waveform, amplitude, DC offset, frequency, and start phase.
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_FUNC before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure a standard waveform.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Waveform">
    '''Pass the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_WAVEFORM to this value.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_WFM_SINE      - Sinusoidal waveform
    '''NIFGEN_VAL_WFM_SQUARE    - Square waveform 
    '''NIFGEN_VAL_WFM_TRIANGLE  - Triangular waveform
    '''NIFGEN_VAL_WFM_RAMP_UP   - Positive ramp waveform 
    '''NIFGEN_VAL_WFM_RAMP_DOWN - Negative ramp waveform 
    '''NIFGEN_VAL_WFM_DC        - Constant voltage
    '''NIFGEN_VAL_WFM_NOISE     - White noise
    '''NIFGEN_VAL_WFM_USER      - User-defined waveform as defined 
    '''                           with 
    '''                           niFgen_DefineUserStandardWaveform
    '''
    '''Default Value: NIFGEN_VAL_WFM_SINE      
    '''</param>
    '''<param name="Amplitude">
    '''Pass the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value. 
    '''
    '''For example, to produce a waveform ranging from -5.00 V to +5.00 V, set the amplitude to 10.00 V.
    '''
    '''Note: This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''Units: Vpk-pk
    '''
    '''Default Value: None
    '''
    '''
    '''</param>
    '''<param name="DC_Offset">
    '''Pass the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal. The value is the offset from ground to the center of the waveform you specify with the waveform parameter.  NI-FGEN sets NIFGEN_ATTR_FUNC_DC_OFFSET to this value.  
    '''
    '''For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 V to +10.00 V, set the DC Offset to 5.00 V.
    '''
    '''Units: volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Frequency">
    '''Pass the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_FREQUENCY to this value.
    '''
    '''Notes:
    '''
    '''(1) This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''(2) Frequency ranges vary from device to device.
    '''
    '''Units: Hz
    '''
    '''Default Value: None
    '''</param>
    '''<param name="Start_Phase">
    '''Pass the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets NIFGEN_ATTR_FUNC_START_PHASE to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
    '''
    '''Note: This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''Units: Degrees of one cycle
    '''
    '''Default Value: 0.00 degrees
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureStandardWaveform(ByVal Channel_Name As String, ByVal Waveform As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Frequency As Double, ByVal Start_Phase As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureStandardWaveform(Me._handle, Channel_Name, Waveform, Amplitude, DC_Offset, Frequency, Start_Phase)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Defines a user waveform for either standard function output or frequency list output.  
    '''
    '''To select the waveform, set the waveform parameter to NIFGEN_VAL_WFM_USER with either niFgen_ConfigureStandardWaveform or niFgen_CreateFreqList.
    '''
    '''The waveform data must be scaled between -1.0 and 1.0. Use the amplitude parameter to generate different output voltages. 
    '''
    '''For the NI 5401/5411/5431, the waveform must be exactly 16,384 points. 
    '''
    '''Note: 
    '''
    '''You must set Output_Mode to NIFGEN_VAL_OUTPUT_FUNC or NIFGEN_VAL_OUTPUT_FREQ_LIST using niFgen Configure Output Mode before calling this function.  
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure an arbitrary sequence.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Waveform_Size">
    '''Pass the size of the arbitrary waveform you want to create.
    '''
    '''For the NI 5401/5411/5431, the waveform must be exactly 16,384 points.
    '''
    '''Default Value: 16384
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specify the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
    '''
    '''You must normalize the data points in the array to be between -1.00 and +1.00.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function DefineUserStandardWaveform(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.DefineUserStandardWaveform(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Clears the user-defined waveform created by niFgen_DefineUserStandardWaveform.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name from which you want to clear the waveform.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ClearUserStandardWaveform(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearUserStandardWaveform(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the frequency of the standard waveform that you want the signal generator to produce.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure a standard waveform.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Frequency">
    '''Pass the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_FREQUENCY to this value.
    '''
    '''Notes:
    '''
    '''(1) This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''(2) For NIFGEN_VAL_WFM_SINE, the range is between 0 MHz and 16 MHz, but is between 0 MHz and 1 MHz for all other waveforms.
    '''
    '''Units: Hz
    '''
    '''Default Value: None
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureFrequency(ByVal Channel_Name As String, ByVal Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureFrequency(Me._handle, Channel_Name, Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the amplitude of the standard waveform that you want the signal generator to produce.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure a standard waveform.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Amplitude">
    '''The peak-to-peak amplitude of the generated waveform in Volts. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureAmplitude(ByVal Channel_Name As String, ByVal Amplitude As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureAmplitude(Me._handle, Channel_Name, Amplitude)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''A frequency list consists of a list of frequencies and durations. The signal generator generates each frequency for the given amount of time and then moves on to the next frequency. When the end of the list is reached, the signal generator starts over at the beginning of the list.  
    ''' 
    '''This function creates a frequency list from an array of frequencies and an array of durations. Each array must be of the same size, which must match the frequencyListLength parameter. The function returns a handle that identifies the frequency list. You can pass this handle to niFgen_ConfigureFreqList to specifiy what frequency list you want the signal generator to produce.
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform">
    '''Pass the standard waveform that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FUNC_WAVEFORM to this value.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_WFM_SINE      - Sinusoid waveform
    '''NIFGEN_VAL_WFM_SQUARE    - Square waveform 
    '''NIFGEN_VAL_WFM_TRIANGLE  - Triangle waveform
    '''NIFGEN_VAL_WFM_RAMP_UP   - Positive ramp waveform 
    '''NIFGEN_VAL_WFM_RAMP_DOWN - Negative ramp waveform 
    '''NIFGEN_VAL_WFM_DC        - Constant voltage
    '''NIFGEN_VAL_WFM_NOISE     - White noise
    '''NIFGEN_VAL_WFM_USER      - User-defined waveform, as defined by
    '''                           niFgen_DefineUserStandardWaveform
    '''
    '''Default Value: NIFGEN_VAL_WFM_SINE
    '''
    '''</param>
    '''<param name="Frequency_List_Length">
    '''The number of steps in the frequency list you want to create. The value must be between the miniumum and maximum frequency list lengths that the signal generator allows. You can obtain the minimum and maximum frequency list lengths from the minimumFrequencyListLength and maximumFrequencyListLength parameters in niFgen_QueryFreqListCapabilities.
    '''
    '''The frequencyArray and the durationArray parameters must each be at least as long as this frequency list length.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Frequency_Array">
    '''Pass the array of frequencies to form the frequency list. The array must have at least as many elements as the value you specify in the frequencyListLength parameter. Each frequencyArray element has a corresponding durationArray element that indicates how long that frequency is repeated.  
    '''
    '''Units: Hz
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Duration_Array">
    '''Pass the array of durations to form the frequency list. The array must have at least as many elements as the value that you specify in the frequencyListLength parameter. Each durationArray element has a corresponding frequencyArray element and indicates how long in seconds to generate the corresponding frequency.  
    '''
    '''Units: Seconds
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Frequency_List_Handle">
    '''Returns the handle that identifies the new frequency list. You can pass this handle to niFgen_ConfigureFreqList to generate the arbitrary sequence.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateFreqList(ByVal Waveform As Integer, ByVal Frequency_List_Length As Integer, ByVal Frequency_Array() As Double, ByVal Duration_Array() As Double, ByRef Frequency_List_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateFreqList(Me._handle, Waveform, Frequency_List_Length, Frequency_Array, Duration_Array, Frequency_List_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the attributes of the signal generator that affect frequency list generation. These attributes are the frequency list handle, amplitude, DC offset, and start phase.
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure a frequency list.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Frequency_List_Handle">
    '''Pass the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_FREQ_LIST_HANDLE to this value. You can create a frequency list using niFgen_CreateFreqList. niFgen_CreateFreqList returns a handle that you use to identify the list.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Amplitude">
    '''Pass the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets NIFGEN_ATTR_FUNC_AMPLITUDE to this value.
    '''
    '''For example, to produce a waveform ranging from -5.00 V to +5.00 V, set the amplitude to 10.00 V.
    '''
    '''Note: This parameter does not affect signal generator behavior when you set the Waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''Units: Vpk-pk
    '''
    '''Default Value: None
    '''
    '''
    '''
    '''</param>
    '''<param name="DC_Offset">
    '''Pass the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal. The value is the offset from ground to the center of the waveform you specify with the Waveform parameter.  NI-FGEN sets NIFGEN_ATTR_FUNC_DC_OFFSET to this value.  
    '''
    '''For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 V to +10.00 V, set the DC Offset to 5.00 V.
    '''
    '''Units: volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Start_Phase">
    '''Pass the horizontal offset of the standard waveform that you want the signal generator to produce. Specify this parameter in degrees of one waveform cycle. NI-FGEN sets NIFGEN_ATTR_FUNC_START_PHASE to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle. A start phase of 360 degrees is identical to a start phase of 0 degrees.
    '''
    '''Note: This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
    '''
    '''Units: Degrees of one cycle
    '''
    '''Default Value: None
    '''
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureFreqList(ByVal Channel_Name As String, ByVal Frequency_List_Handle As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Start_Phase As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureFreqList(Me._handle, Channel_Name, Frequency_List_Handle, Amplitude, DC_Offset, Start_Phase)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Removes a previously created frequency list from the signal generator memory and invalidates the frequency list handle.
    '''
    '''Note: The signal generator must not be in the Generating state when you call this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Frequency_List_Handle">
    '''Pass the handle of the frequency list you want the signal generator to remove. You create multiple frequency lists using niFgen_CreateFreqList. niFgen_CreateFreqList returns a handle that you use to identify each list.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_ALL_FLISTS - Remove all frequency lists from the signal generator.
    ''' 
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ClearFreqList(ByVal Frequency_List_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearFreqList(Me._handle, Frequency_List_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the attributes of the signal generator that are related to creating frequency lists.  These attributes are the maximum number of frequency lists, minimum frequency list length, maximum frequency list length, minimum frequency list duration, maximum frequency list duration, and frequency list duration quantum. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Maximum_Number_Of_Freq_Lists">
    '''Returns the maximum number of frequency lists that the signal generator allows. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_FREQ_LISTS.  
    '''
    '''
    '''</param>
    '''<param name="Minimum_Frequency_List_Length">
    '''Returns the minimum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH.
    '''
    '''
    '''</param>
    '''<param name="Maximum_Frequency_List_Length">
    '''Returns the maximum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH.
    ''' 
    '''
    '''</param>
    '''<param name="Minimum_Frequency_List_Duration">
    '''Returns the minimum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_FREQ_LIST_DURATION.
    '''
    '''
    '''</param>
    '''<param name="Maximum_Frequency_List_Duration">
    '''Returns the maximum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_FREQ_LIST_DURATION.
    ''' 
    '''
    '''</param>
    '''<param name="Frequency_List_Duration_Quantum">
    '''Returns the quantum of which all durations must be a multiple in a frequency list. NI-FGEN obtains this value from NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM.
    ''' 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function QueryFreqListCapabilities(ByRef Maximum_Number_Of_Freq_Lists As Integer, ByRef Minimum_Frequency_List_Length As Integer, ByRef Maximum_Frequency_List_Length As Integer, ByRef Minimum_Frequency_List_Duration As Double, ByRef Maximum_Frequency_List_Duration As Double, ByRef Frequency_List_Duration_Quantum As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryFreqListCapabilities(Me._handle, Maximum_Number_Of_Freq_Lists, Minimum_Frequency_List_Length, Maximum_Frequency_List_Length, Minimum_Frequency_List_Duration, Maximum_Frequency_List_Duration, Frequency_List_Duration_Quantum)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the amount of gain to apply to the waveform.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the gain.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Gain">
    '''Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
    '''
    '''For example, to configure the output signal to range from 
    '''-2.00 V to +2.00 V, set the gain to 2.00.
    '''
    '''Units: Volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureGain(ByVal Channel_Name As String, ByVal Gain As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureGain(Me._handle, Channel_Name, Gain)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the sample rate attribute, which determines the rate at which the signal generator produces arbitrary waveforms.  When you configure the signal generator to produce an arbitrary sequence, this is the sample rate for all arbitrary waveforms in the sequence.
    '''  
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sample_Rate">
    '''Pass the sample rate at which you want the signal generator to generate arbitrary waveforms. NI-FGEN sets NIFGEN_ATTR_ARB_SAMPLE_RATE to this value. 
    '''
    '''Units: S/s
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureSampleRate(ByVal Sample_Rate As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSampleRate(Me._handle, Sample_Rate)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the attributes of the signal generator that are related to creating arbitrary waveforms. These attributes are the maximum number of waveforms, waveform quantum, minimum waveform size, and maximum waveform size.
    '''
    '''Note: If you do not want to obtain the waveform quantum, pass a value of VI_NULL for this parameter. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Maximum_Number_of_Waveforms">
    '''Returns the maximum number of arbitrary waveforms that the signal generator allows. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_WAVEFORMS.
    '''
    '''
    '''</param>
    '''<param name="Waveform_Quantum">
    '''The size (number of points) of each waveform must be a multiple of a constant quantum value. This parameter obtains the quantum value that the signal generator uses. NI-FGEN returns this value from NIFGEN_ATTR_WAVEFORM_QUANTUM. 
    '''
    '''For example, when this attribute returns a value of 8, all waveform sizes must be a multiple of 8.
    '''
    '''</param>
    '''<param name="Minimum_Waveform_Size">
    '''Returns the minimum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from NIFGEN_ATTR_MIN_WAVEFORM_SIZE.  
    '''
    '''
    '''</param>
    '''<param name="Maximum_Waveform_Size">
    '''Returns the maximum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from NIFGEN_ATTR_MAX_WAVEFORM_SIZE.
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function QueryArbWfmCapabilities(ByRef Maximum_Number_of_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Minimum_Waveform_Size As Integer, ByRef Maximum_Waveform_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryArbWfmCapabilities(Me._handle, Maximum_Number_of_Waveforms, Waveform_Quantum, Minimum_Waveform_Size, Maximum_Waveform_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Creates an onboard waveform from binary F64 (floating point double) data for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
    '''
    '''Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Size">
    '''Pass the size of the arbitrary waveform that you want created.
    '''
    '''The size must meet the following restrictions:
    '''
    '''- The size must be less than or equal to the maximum waveform size that the device allows.
    '''- The size must be greater than or equal to the minimum waveform size that the device allows.
    '''- The size must be an integer multiple of the device waveform quantum.
    '''
    '''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the Waveform Size parameter.
    '''
    '''You must normalize the data points in the array to be between -1.00 and +1.00.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformF64(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformF64(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Creates an onboard waveform from binary I16 data for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
    '''
    '''Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Size">
    '''Pass the size of the arbitrary waveform that you want created.
    '''
    '''The size must meet the following restrictions:
    '''
    '''- The size must be less than or equal to the maximum waveform size that the instrument allows.
    '''- The size must be greater than or equal to the minimum waveform size the instrument allows.
    '''- The size must be an integer multiple of the instrument waveform quantum.
    '''
    '''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
    '''
    '''You must normalize the data points in the array to be between -32768 and +32767.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformI16(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Short, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformI16(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Creates an onboard waveform from complex double-precision floating-point data for use with the NIFGEN_ATTR_OUTPUT_MODE attribute set to Arbitrary Waveform mode or Arbitrary Sequence mode on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attibute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Number_of_Samples">
    '''Pass the size of the arbitrary waveform that you want created.
    '''
    '''The size must meet the following restrictions:
    '''
    '''- The size must be less than or equal to the maximum waveform size that the device allows.
    '''- The size must be greater than or equal to the minimum waveform size that the device allows.
    '''- The size must be an integer multiple of the device waveform quantum.
    '''
    '''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specifies the array of data you want to load into the new waveform. The array must have at least as many elements as the value that you specify in the Number of Samples parameter.
    '''
    '''You must normalize the data points in the array to be between -1.00 and +1.00.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformComplexF64(ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Waveform_Data_Array As niFgenComplexF64, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformComplexF64(Me._handle, Channel_Name, Number_of_Samples, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''This function takes the binary I16 data from the specified file and creates an onboard waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
    '''
    '''Notes:  
    '''
    '''Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''
    '''The i16 data (values between -32768 and +32767) is assumed to represent -1 to +1 volts.  Use the Gain attribute to generate different voltage outputs. 
    '''
    '''You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ (using the Configure Output Mode function) before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to create a waveform.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="FileName">
    '''The full path and name of the file where the waveform data resides.
    '''</param>
    '''<param name="Byte_Order">
    '''Specifies the byte order of the data in the file.
    '''
    '''Defined Values:
    '''
    '''NIFGEN_VAL_LITTLE_ENDIAN - Little Endian Data
    '''NIFGEN_VAL_BIG_ENDIAN - Big Endian Data
    '''
    '''Default Value: NIFGEN_VAL_LITTLE_ENDIAN
    '''
    '''
    '''Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformFromFileI16(ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileI16(Me._handle, Channel_Name, FileName, Byte_Order, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''This function takes the F64 (floating point double) data from the specified file and creates an onboard waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned  can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
    '''
    '''Notes:  
    '''
    '''Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''
    '''The F64 data must be between -1.0 and +1.0.  Use the Gain attribute to generate different voltage outputs. 
    '''
    '''You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ (using the Configure Output Mode function) before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to create a waveform.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="FileName">
    '''The full path and name of the file where the waveform data resides.
    '''</param>
    '''<param name="Byte_Order">
    '''Specifies the byte order of the data in the file.
    '''
    '''Defined Values:
    '''
    '''NIFGEN_VAL_LITTLE_ENDIAN - Little Endian Data
    '''NIFGEN_VAL_BIG_ENDIAN - Big Endian Data
    '''
    '''Default Value: NIFGEN_VAL_LITTLE_ENDIAN
    '''
    '''
    '''Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformFromFileF64(ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileF64(Me._handle, Channel_Name, FileName, Byte_Order, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''This function takes the waveform data from the specified HWS (Hierarchical Waveform Storage) file and creates an onboard  waveform for use in Arbitrary Waveform mode or Arbitrary Sequence mode.  The waveform handle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms or even deleting the waveform when it is no longer needed.
    '''
    '''When the Analog Waveform Editor saves data in an HWS file, it also stores the rate, gain and offset with the data.  If the Use Rate from Waveform and Use Gain and Offset from Waveform inputs are set to True, this function will also set those properties on NI-FGEN. 
    '''
    '''Notes:
    '''
    '''(1)  If you choose to have this function set the gain and offset properties for you, you should NOT use the niFgen Configure Arbitrary Waveform or niFgen Configure Arbitrary Sequence functions, as they also set the gain and offset, thereby overriding the values set by this function.  Instead, use the Arbitrary Waveform Handle or Arbitrary Sequence Handle attributes in the niFgen property node.
    '''
    '''(2) If you set the Use Rate from Waveform input to True and if Onboard Signal Processsing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
    '''
    '''(3) HWS files may contain I16 or DBL data (depending on how it was saved).  This function will automatically adapt to either data type.  If the file contains DBL data, it must be between -1.0 and +1.0.  Check the "Scale Data to +/- 1V" option in the Analog Waveform Editor to ensure your data is between -1.0 and +1.0.
    '''
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to create a waveform.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="FileName">
    '''The full path and name of the file where the waveform data resides.
    '''</param>
    '''<param name="Use_Rate_From_Waveform">
    '''If you set the Use Rate from Waveform input to True and if Onboard Signal Processsing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Use rate from waveform
    '''VI_FALSE - Do not use rate from waveform
    '''
    '''Default Value: VI_TRUE
    '''</param>
    '''<param name="Use_Gain___Offset_From_Waveform">
    '''If this input is set to VI_TRUE (which it is by default), NI-FGEN retrieves the gain and offset values from the specified HWS file and applies them to the NI-FGEN driver.
    '''
    '''Defined Values
    '''
    '''VI_TRUE  - Use gain and offset from waveform
    '''VI_FALSE - Do not use gain and offset from waveform
    '''
    '''Default Value: VI_TRUE
    '''</param>
    '''<param name="Waveform_Handle">
    '''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateWaveformFromFileHWS(ByVal Channel_Name As String, ByVal FileName As String, ByVal Use_Rate_From_Waveform As Boolean, ByVal Use_Gain___Offset_From_Waveform As Boolean, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileHWS(Me._handle, Channel_Name, FileName, System.Convert.ToUInt16(Use_Rate_From_Waveform), System.Convert.ToUInt16(Use_Gain___Offset_From_Waveform), Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Configures the attributes of the signal generator that affect arbitrary waveform generation. These attributes are the arbitrary waveform handle, gain, and offset.
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure an arbitrary waveform.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''Pass the handle of the arbitrary waveform you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_ARB_WAVEFORM_HANDLE to this value. You can create an arbitrary waveform using one of the following niFgen Create Waveform functions:
    '''
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''These functions return a handle that you use to identify the waveform.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Gain">
    '''Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
    '''
    '''For example, to configure the output signal to range from 
    '''-2.00 V to +2.00 V, set the gain to 2.00.
    '''
    '''Units: Volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Offset">
    '''Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 V to +1.00 V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets NIFGEN_ATTR_ARB_OFFSET to this value.
    '''
    '''For example, to configure the output signal to range from 0.00 V to 2.00 V instead of -1.00 V to 1.00 V, set the offset to 1.00.
    '''
    '''Units: Volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the include files that contain the defined constants for the particular status codes
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureArbWaveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureArbWaveform(Me._handle, Channel_Name, Waveform_Handle, Gain, Offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
    '''
    '''Note: The signal generator must not be in the Generating state when you call this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''Pass the handle of the arbitrary waveform that you want the signal generator to remove. You can create multiple arbitrary waveforms using one of the following niFgen Create Waveform functions: 
    '''
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''These functions return a handle that you use to identify each waveform.
    '''
    '''Defined Value
    '''
    '''NIFGEN_VAL_ALL_WAVEFORMS - Remove all waveforms from the signal generator.
    '''    
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ClearArbWaveform(ByVal Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbWaveform(Me._handle, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the attributes of the signal generator that are related to creating arbitrary sequences.  These attributes are the maximum number of sequences, minimum sequence length, maximum sequence length, and maximum loop count.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Maximum_Number_of_Sequences">
    '''Returns the maximum number of arbitrary waveform sequences that the signal generator allows.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_NUM_SEQUENCES.  
    '''
    '''
    '''</param>
    '''<param name="Minimum_Sequence_Length">
    '''Returns the minimum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MIN_SEQUENCE_LENGTH.
    '''
    '''
    '''</param>
    '''<param name="Maximum_Sequence_Length">
    '''Returns the maximum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_SEQUENCE_LENGTH.
    ''' 
    '''
    '''</param>
    '''<param name="Maximum_Loop_Count">
    '''Returns the maximum number of times the signal generator can repeat an arbitrary waveform in a sequence.  NI-FGEN obtains this value from NIFGEN_ATTR_MAX_LOOP_COUNT.
    '''
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list defines the ranges of additional status codes that NI-FGEN can return.  with the include files that contain the defined constants for the particular status codes
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function QueryArbSeqCapabilities(ByRef Maximum_Number_of_Sequences As Integer, ByRef Minimum_Sequence_Length As Integer, ByRef Maximum_Sequence_Length As Integer, ByRef Maximum_Loop_Count As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryArbSeqCapabilities(Me._handle, Maximum_Number_of_Sequences, Minimum_Sequence_Length, Maximum_Sequence_Length, Maximum_Loop_Count)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''An arbitrary sequence consists of multiple waveforms. For each waveform, you can specify the number of times that the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count.
    ''' 
    '''This function creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. The function returns a handle that identifies the sequence. You pass this handle to niFgen_ConfigureArbSequence to specify what arbitrary sequence you want the signal generator to produce.
    '''
    '''Note:  You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sequence_Length">
    '''Pass the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from the minimumSequenceLength and maximumSequenceLength parameters in niFgen_QueryArbSeqCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handles_Array">
    '''Pass the array of waveform handles from which you want to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the Sequence_Length parameter. Each waveformHandlesArray element has a corresponding loopCountsArray element that indicates how many times that waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with niFgen_AllocateWaveform or one of the following niFgen_CreateWaveform functions:
    '''
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Loop_Counts_Array">
    '''Pass the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the Sequence Length parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from the maximumLoopCount parameter in niFgen_QueryArbSeqCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sequence_Handle">
    '''Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateArbSequence(ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array() As Long, ByVal Loop_Counts_Array() As Long, ByRef Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateArbSequence(Me._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''An arbitrary sequence consists of multiple waveforms.  For each waveform, you specify the number of times the signal generator produces the waveform before proceeding to the next waveform.  The number of times to repeat a specific waveform is called the loop count.
    ''' 
    '''This function creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts.  The function returns a handle that identifies the sequence.  You pass this handle to niFgen_ConfigureArbSequence to specify what arbitrary sequence you want the signal generator to produce.
    '''
    '''niFgen_CreateAdvancedArbSequence extends on niFgen_CreateArbSequence by adding the ability to set the number of samples in each sequence step and to set marker locations.   
    '''
    '''Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Sequence_Length">
    '''Pass the number of waveforms in the new arbitrary sequence that you want to create.  The value you pass must be between the minimum and maximum sequence lengths the signal generator allows.  You can obtain the minimum and maximum sequence lengths from the minimumSequenceLength and maximumSequenceLength parameters in niFgen_QueryArbSeqCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handles_Array">
    '''Pass the array of waveform handles from which you want to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter. Each waveformHandlesArray element has a corresponding loopCountsArray element that indicates how many times that waveform is repeated.  You obtain waveform handles when you create arbitrary waveforms with one of the niFgen Create Waveform functions or with niFgen_AllocateWaveform.
    '''
    '''The niFgen Create Waveform functions are as follows:
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Loop_Counts_Array">
    '''Pass the array of loop counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform.  Each element of the loopCountArray must be less than or equal to the maximum number of loop counts the signal generator allows.  You can obtain the maximum loop count from the maximumLoopCount parameter of niFgen_QueryArbSeqCapabilities.
    '''
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sample_Counts_Array">
    '''Pass the array of sample counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each sampleCountsArray element corresponds to a waveformHandlesArray element and indicates how many samples of the given waveform to generate.  Each element of the sampleCountArray must be larger than the minimum waveform size and a multiple of the waveform quantum.  You can obtain these values by calling niFgen_QueryArbWfmCapabilities.  
    '''
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Marker_Location_Array">
    '''Pass the array of marker locations to where you want a marker to be generated in the sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each markerLocationArray element corresponds to a waveformHandlesArray element and indicates where in the waveform a marker is to generate.  The marker location must be less than the size of the waveform the marker is in.  The markers are coerced to the nearest marker quantum and the coereced values are returned in the coercedMarkersArray parameter.  
    '''
    '''If you do not want a marker generated for a particular sequence stage, set the marker to NIFGEN_VAL_NO_MARKER.
    '''
    '''Defined Values: NIFGEN_VAL_NO_MARKER
    '''
    '''Default Value: None
    '''</param>
    '''<param name="Coerced_Markers_Array">
    '''Returns an array of all given markers that are coerced (rounded) to the nearest marker quantum. Not all devices coerce markers.
    ''' 
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sequence_Handle">
    '''Returns the handle that identifies the new arbitrary sequence.  You pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateAdvancedArbSequence(ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array() As Long, ByVal Loop_Counts_Array() As Long, ByVal Sample_Counts_Array() As Long, ByVal Marker_Location_Array() As Long, ByVal Coerced_Markers_Array() As Long, ByRef Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateAdvancedArbSequence(Me._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sample_Counts_Array, Marker_Location_Array, Coerced_Markers_Array, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Configures the signal generator attributes that affect arbitrary sequence generation. These attributes are the arbitrary sequence handle, gain, and offset.
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure an arbitrary sequence.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Sequence_Handle">
    '''Pass the handle of the arbitrary sequence that you want the signal generator to produce. NI-FGEN sets NIFGEN_ATTR_ARB_SEQUENCE_HANDLE to this value. You can create an arbitrary sequence using niFgen_CreateArbSequence. niFgen_CreateArbSequence returns a handle that you use to identify the sequence.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Gain">
    '''Specifies the factor by which the signal generator scales the arbitrary waveforms in the sequence. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 to +1.00. You can use this parameter to scale the waveforms in the sequence to other ranges. NI-FGEN sets NIFGEN_ATTR_ARB_GAIN to this value.
    '''
    '''For example, to configure the output signal to range from -2.00 V to +2.00 V, set the gain to 2.00.
    '''
    '''Units: Volts
    '''
    '''Default Value: None
    '''</param>
    '''<param name="Offset">
    '''Specifies the value the signal generator adds to the arbitrary waveforms in the sequence. When you create arbitrary waveforms, you must first normalize the data points to a range of -1.00 to +1.00. You can use this parameter to shift the ranges of the arbitrary waveforms in the sequence. NI-FGEN sets NIFGEN_ATTR_ARB_OFFSET to this value.
    '''
    '''For example, to configure the output signal to range from 0.00 V to 2.00 V instead of -1.00 V to 1.00 V, set offset to 1.00.
    '''
    '''Units: Volts
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return .
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureArbSequence(ByVal Channel_Name As String, ByVal Sequence_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureArbSequence(Me._handle, Channel_Name, Sequence_Handle, Gain, Offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Removes a previously created arbitrary sequence from the signal generator memory and invalidates the sequence handle.
    '''
    '''Note:  The signal generator must not be in the Generating state when you call this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Sequence_Handle">
    '''Pass the handle of the arbitrary sequence you want the signal generator to remove. You can create multiple arbitrary sequences using niFgen_CreateArbSequence. niFgen_CreateArbSequence returns a handle that you use to identify each sequence.
    '''
    '''Defined Value
    '''
    '''NIFGEN_VAL_ALL_SEQUENCES - Remove all sequences from the signal generator
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ClearArbSequence(ByVal Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbSequence(Me._handle, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Removes all previously created arbitrary waveforms and sequences from the signal generator memory, and invalidates all waveform and sequence handles.
    '''
    '''Note:  The signal generator must not be in the Generating state when you call this function.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Include       Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list defines the ranges of additional status codes that NI-FGEN can return with the different include files that contain the defined constants for the particular status codes.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ClearArbMemory() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbMemory(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Specifies the size of a waveform up-front so that it can be allocated in onboard memory before loading the associated data.  Data can then be loaded in smaller chunks with the Write(Binary16)Waveform functions.  
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to allocate the waveform.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Size">
    '''Specifies the size of the waveform to allocate in samples.
    '''</param>
    '''<param name="Waveform_Handle">
    '''Return Value: The handle that identifies the waveform.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''</returns>
    Public Function AllocateWaveform(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.AllocateWaveform(Me._handle, Channel_Name, Waveform_Size, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sets the position in the waveform to which data is written at the next write. This function allows you to write to arbitrary locations within the waveform. These settings apply only to the next write to the waveform specified by the waveformHandle parameter. Subsequent writes to that waveform begin where the last write left off, unless this function is called again. The waveformHandle passed in must have been created with a call to one of the following functions:
    '''- niFgen_AllocateWaveform
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The channel on which to the waveform data should be loaded.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Handle">
    '''Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform.
    '''</param>
    '''<param name="relativeTo">
    '''Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_WAVEFORM_POSITION_START   0
    '''NIFGEN_VAL_WAVEFORM_POSITION_CURRENT 1
    '''</param>
    '''<param name="offset">
    '''Specifies the offset from the relativeTo parameter at which to start loading the data into the waveform. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''</returns>
    Public Function SetWaveformNextWritePosition(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetWaveformNextWritePosition(Me._handle, Channel_Name, Waveform_Handle, relativeTo, offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Writes floating-point data to the waveform in onboard memory.  The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or to one of the niFgen Create Waveform functions. 
    '''
    '''The niFgen Create Waveform functions are as follows:
    '''
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The channel on which to the waveform data should be loaded.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Handle">
    '''Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
    '''</param>
    '''<param name="Size">
    '''Specifies the number of samples to load into the waveform.
    '''
    '''Default Value: 0
    '''</param>
    '''<param name="Data">
    '''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in the Size parameter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''</returns>
    Public Function WriteWaveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteWaveform(Me._handle, Channel_Name, Waveform_Handle, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Writes complex data to the waveform in onboard memory on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or to one of the niFgen Create Waveform functions. 
    '''
    '''The niFgen Create Waveform functions are as follows:
    '''
    '''- niFgen_CreateWaveformF64
    '''- niFgen_CreateWaveformI16
    '''- niFgen_CreateWaveformFromFileI16
    '''- niFgen_CreateWaveformFromFileF64
    '''- niFgen_CreateWaveformFromFileHWS
    '''
    '''The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The channel on which to the waveform data should be loaded.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Number_of_Samples">
    '''Specifies the number of samples to load into the waveform.
    '''
    '''Default Value: 0
    '''</param>
    '''<param name="Data">
    '''Specifies the array of data to load into the waveform. You must normalize the data points in the array to be between -1.00 and +1.00. The array must have at least as many elements as the value in the Number of Samples parameter.
    '''</param>
    '''<param name="Waveform_Handle">
    '''Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''</returns>
    Public Function WriteWaveformComplexF64(ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Data As niFgenComplexF64, ByVal Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteWaveformComplexF64(Me._handle, Channel_Name, Number_of_Samples, Data, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Writes binary data to the waveform in onboard memory. The waveform handle passed in must have been created by a call to niFgen_AllocateWaveform or niFgen_CreateWaveformI16.
    '''
    '''The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The channel on which to the waveform data should be loaded.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Waveform_Handle">
    '''Specifies the handle of the arbitrary waveform previously allocated with niFgen_AllocateWaveform. 
    '''</param>
    '''<param name="Size">
    '''Specifies the number of samples to load into the waveform.
    '''
    '''Default Value: 0
    '''</param>
    '''<param name="Data">
    '''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in the size parameter. The binary data is left-justified.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''</returns>
    Public Function WriteBinary16Waveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data() As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteBinary16Waveform(Me._handle, Channel_Name, Waveform_Handle, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Configures the signal generator reference clock source. The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Reference_Clock_Source">
    '''Pass the reference clock source that you want the signal generator to use. NI-FGEN sets NIFGEN_ATTR_REF_CLOCK_SOURCE to this value.
    '''
    '''The signal generator derives the frequencies and sample rates that it uses to generate waveforms from the source you specify.
    '''
    '''For example, when you set this parameter to NIFGEN_VAL_REF_CLOCK_EXTERNAL, the signal generator uses the signal it receives at its external clock terminal as the reference clock.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_REF_CLOCK_INTERNAL   - Internal clock source
    '''NIFGEN_VAL_REF_CLOCK_EXTERNAL   - External clock source
    '''NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK - RTSI clock
    '''NIFGEN_VAL_REF_CLOCK_TTL7       - TTL 7 line
    '''NIFGEN_VAL_PXI_CLK10            - PXI 10 MHz clock
    '''NIFGEN_VAL_REF_IN               - External clock source
    '''NIFGEN_VAL_RTSI_0               - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1               - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2               - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3               - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4               - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5               - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6               - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_RTSI_7               - RTSI 7 or PXI_Trig 7
    '''NIFGEN_VAL_CLK_IN               - CLK IN front panel connector
    '''
    '''Default Value: NIFGEN_VAL_REF_CLOCK_INTERNAL
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureRefClockSource(ByVal Reference_Clock_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureRefClockSource(Me._handle, Reference_Clock_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Configures the signal generator reference clock frequency.  The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
    '''
    '''Note:  The signal generator must not be in the Generating state when you call this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Reference_Clock_Frequency">
    '''The reference clock frequency in hertz.
    '''
    '''Default Value: 10000000
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureRefClockFrequency(ByVal Reference_Clock_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureRefClockFrequency(Me._handle, Reference_Clock_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Selects the clock mode for the signal generator.  
    '''
    '''For signal generators that support it, this function allows you to switch the sample clock to High-Resolution Sampling mode. 
    '''
    '''When in Divide-Down Sampling mode, you can only set the sample rate to certain frequences, based on dividing down the update clock. However, in High-Resolution Sampling mode, you can set the sample rate to any value.  
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Clock_Mode">
    '''Sets the clock mode of the signal generator. 
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_DIVIDE_DOWN
    '''NIFGEN_VAL_HIGH_RESOLUTION
    '''NIFGEN_VAL_AUTOMATIC
    '''
    '''Default value: Depends on the device.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return .
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureClockMode(ByVal Clock_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureClockMode(Me._handle, Clock_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sets the source of the update clock of the signal generator.  The source can be internal or external.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Update_Clock_Source">
    '''Controls the update clock source.
    '''
    '''Defined Values
    '''  
    '''NIFGEN_VAL_INTERNAL   - Internal clock source
    '''NIFGEN_VAL_EXTERNAL   - External clock source
    '''NIFGEN_VAL_PXI_STAR   - PXI Star
    '''NIFGEN_VAL_RTSI_0     - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1     - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2     - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3     - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4     - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5     - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6     - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_RTSI_7     - RTSI 7 or PXI_Trig 7
    '''NIFGEN_VAL_CLK_IN     - CLK IN front panel connector
    '''NIFGEN_VAL_DDC_CLK_IN - Digital Data &amp; Control clock in
    '''
    '''Default Value: NIFGEN_VAL_INTERNAL
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureUpdateClockSource(ByVal Update_Clock_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureUpdateClockSource(Me._handle, Update_Clock_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Delays (or phase shifts) the sample clock, which delays the output of the module.  Delaying the sample clock can be useful when lining up the output of multiple modules or when intentionally phase shifting the output relative to a fixed reference such as the PLL reference clock.  
    '''
    '''Adjustment time can be positive or negative, but it must be less than or equal to the sample clock period.  The delay takes effect immediately after this function is called.  To delay an external sample clock, use NIFGEN_ATTR_SAMPLE_CLOCK_ABSOLUTE_DELAY.
    '''
    '''Note:  Calling this function after calling NI-TClk Synchronize may cause synchronization to become undone.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Adjustment_Time">
    '''The amount of time to adjust the sample clock delay in seconds.
    '''
    '''Default Value: 0
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function AdjustSampleClockRelativeDelay(ByVal Adjustment_Time As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.AdjustSampleClockRelativeDelay(Me._handle, Adjustment_Time)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Configures the trigger source. The signal generator responds to a trigger depending on the operation mode in which the signal generator is operating.
    '''
    '''Note: The signal generator must not be in the Generating state when you call this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the trigger source.
    '''
    '''Defined Channel Name
    '''
    '''0
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Trigger_Source">
    '''Controls which trigger source the signal generator uses.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_IMMEDIATE     - Immediate
    '''NIFGEN_VAL_EXTERNAL      - External (maps to PFI 0)
    '''NIFGEN_VAL_SOFTWARE_TRIG - Software trigger
    '''NIFGEN_VAL_PXI_STAR      - PXI Star
    '''NIFGEN_VAL_RTSI_0        - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1        - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2        - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3        - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4        - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5        - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6        - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_RTSI_7        - RTSI 7 or PXI_Trig 7
    '''NIFGEN_VAL_TTL0          - TTL 0
    '''NIFGEN_VAL_TTL1          - TTL 1
    '''NIFGEN_VAL_TTL2          - TTL 2
    '''NIFGEN_VAL_TTL3          - TTL 3
    '''NIFGEN_VAL_TTL4          - TTL 4
    '''NIFGEN_VAL_TTL5          - TTL 5
    '''NIFGEN_VAL_TTL6          - TTL 6
    '''NIFGEN_VAL_PFI_0         - PFI 0
    '''NIFGEN_VAL_PFI_1         - PFI 1
    '''NIFGEN_VAL_PFI_2         - PFI 2
    '''NIFGEN_VAL_PFI_3         - PFI 3
    '''
    '''Default Value: Immediate
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureTriggerSource(ByVal Channel_Name As String, ByVal Trigger_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerSource(Me._handle, Channel_Name, Trigger_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sets the trigger mode.
    '''
    '''Supported trigger modes are:
    '''
    '''Single Trigger mode - The waveform that you describe in the sequence list generates only once by going through the entire staging list. Only one trigger is required to start the waveform generation. You can use single trigger mode with the output mode in any mode.  After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. 
    '''
    '''Continuous Trigger mode - The waveform that you describe in the staging list generates infinitely by repeatedly cycling through the staging list. After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. After the last stage is completed, the waveform generation loops back to the start of the first stage and continues until it is stopped. Only one trigger is required to start the waveform generation.
    '''
    '''Stepped Trigger mode - After a start trigger is received, the waveform described by the first stage generates. Then, the device waits for the next trigger signal. On the next trigger, the waveform described by the second stage generates, and so on. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  
    '''
    '''Burst Trigger mode - After a start trigger is received, the waveform described by the first stage generates until another trigger is received. At the next trigger, the buffer of the previous stage completes, and then the waveform described by the second stage generates. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  In Frequency List mode, the duration instruction is ignored, and the trigger switches the frequency to the next frequency in the list.
    '''
    '''Note:  In Frequency List mode, Stepped Trigger mode is the same as Burst Trigger mode.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the trigger mode.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Trigger_Mode">
    '''This sets the trigger mode.
    '''
    '''Defined Values:
    '''
    '''NIFGEN_VAL_SINGLE - Single Trigger mode
    '''NIFGEN_VAL_CONTINUOUS - Continuous Trigger mode
    '''NIFGEN_VAL_STEPPED - Stepped Trigger mode
    '''NIFGEN_VAL_BURST - Burst Trigger mode
    '''
    '''Default Value: NIFGEN_VAL_CONTINUOUS
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureTriggerMode(ByVal Channel_Name As String, ByVal Trigger_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerMode(Me._handle, Channel_Name, Trigger_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Routes various signals in the signal generator to the RTSI lines and front panel terminals.  
    '''
    '''Notes:
    '''
    '''(1) The signal generator must not be in the Generating state when you call this function.
    '''
    '''(2) You can clear a previously routed signal by routing NIFGEN_VAL_NONE to the destination terminal.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to route a signal.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Route_Signal_From">
    '''Specifies the source of the signal to route. 
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_NONE - Route nothing to the RTSI line. Clears the line.
    ''' 
    '''NIFGEN_VAL_MARKER - The marker as specified by the markers parameter in niFgen_CreateAdvancedArbSequence.
    '''
    '''NIFGEN_VAL_SYNC_OUT - The SYNC signal that normally appears on the SYNC_OUT front panel connector.
    '''
    '''NIFGEN_VAL_OUT_START_TRIGGER - The trigger generated at the start of the sequence. Call niFgen_ConfigureTriggerSource to receive this trigger.
    '''
    '''NIFGEN_VAL_BOARD_CLOCK - NIFGEN_VAL_BOARD_CLOCK The signal generator board clock, which is 20 MHz for the NI PCI-5401/5411/5431.  The NI PXI-5404 has a 20 MHz board clock, and the NI PXI-5421 has integer divisors of 100 MHz.  The NI PXI-5401/5411/5431 does not support routing a Board Clock out.
    '''
    '''NIFGEN_VAL_SYNCHRONIZATION - A synchronization strobe used to guarantee absolute synchronization between two or more signal generators. Call niFgen_ConfigureSynchronization to receive the strobe. 
    '''
    '''NIFGEN_VAL_SOFTWARE_TRIG - Software trigger
    '''MIFGEN_VAL_OUT_UPDATE
    '''NIFGEN_VAL_REF_OUT - Reference clock out
    '''NIFGEN_VAL_PXI_CLK10 - PXI 10 MHz clock 
    '''NIFGEN_VAL_PXI_STAR - PXI Star
    '''NIFGEN_VAL_PFI_0 - PFI 0
    '''NIFGEN_VAL_RTSI_0 - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1 - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2 - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3 - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4 - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5 - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6 - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_RTSI_7 - RTSI 7 or PXI_Trig 7
    '''NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK - RTSI Clock
    '''NIFGEN_VAL_CLOCK_OUT - Clock Out
    '''NIFGEN_VAL_UPDATE_CLOCK - Sample Clock
    '''NIFGEN_VAL_PLL_REF_SOURCE - PLL Reference Clock
    '''</param>
    '''<param name="Route_Signal_To">
    '''Specifies the destination of the signal to route.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_RTSI_0 - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1 - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2 - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3 - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4 - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5 - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6 - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_RTSI_CLOCK - RTSI clock
    '''NIFGEN_VAL_REF_OUT - Reference clock out
    '''NIFGEN_VAL_PFI_0 - PFI 0
    '''NIFGEN_VAL_PFI_1 - PFI 1
    '''NIFGEN_VAL_PFI_4 - PFI 4
    '''NIFGEN_VAL_PFI_5 - PFI 5
    '''NIFGEN_VAL_PXI_STAR - PXI Star
    '''NIFGEN_VAL_PXI_CLK10 - PXI 10 MHz clock
    '''NIFGEN_VAL_DDC_CLK_OUT - Digital and Data Control front panel connector
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function RouteSignalOut(ByVal Channel_Name As String, ByVal Route_Signal_From As Integer, ByVal Route_Signal_To As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.RouteSignalOut(Me._handle, Channel_Name, Route_Signal_From, Route_Signal_To)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sets the signal generator to receive a synchronization signal to synchronize two or more NI 5401/5411/5431 signal generators. One signal generator should send a signal to a RTSI line by calling niFgen_RouteSignalOut, and other signal generators should receive the signal by calling niFgen_ConfigureSynchronization.
    '''
    '''Note:  The signal generator must not be in the Generating state when you call this function.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the synchronization signal.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Synchronization_Source">
    '''Specify the source of the synchronization signal you want to use.  
    '''
    '''Defined Values:
    '''
    '''NIFGEN_VAL_NONE         - No synchronization source
    '''NIFGEN_VAL_RTSI_0       - RTSI 0 or PXI_Trig 0
    '''NIFGEN_VAL_RTSI_1       - RTSI 1 or PXI_Trig 1
    '''NIFGEN_VAL_RTSI_2       - RTSI 2 or PXI_Trig 2
    '''NIFGEN_VAL_RTSI_3       - RTSI 3 or PXI_Trig 3
    '''NIFGEN_VAL_RTSI_4       - RTSI 4 or PXI_Trig 4
    '''NIFGEN_VAL_RTSI_5       - RTSI 5 or PXI_Trig 5
    '''NIFGEN_VAL_RTSI_6       - RTSI 6 or PXI_Trig 6
    '''NIFGEN_VAL_TTL0         - TTL 0
    '''NIFGEN_VAL_TTL1         - TTL 1
    '''NIFGEN_VAL_TTL2         - TTL 2
    '''NIFGEN_VAL_TTL3         - TTL 3
    '''NIFGEN_VAL_TTL4         - TTL 4
    '''NIFGEN_VAL_TTL5         - TTL 5
    '''NIFGEN_VAL_TTL6         - TTL 6
    '''
    '''Default Value:
    '''
    '''NIFGEN_VAL_NONE
    '''
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureSynchronization(ByVal Channel_Name As String, ByVal Synchronization_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSynchronization(Me._handle, Channel_Name, Synchronization_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sets the FIR filter coefficients used by the onboard signal processing block. The values are coerced to the closest settings achieveable by the signal generator.
    '''
    '''Refer to Devices&gt;&gt;NI 5441&gt;&gt;Theory of Operation&gt;&gt;Onboard Signal Processing&gt;&gt;Components&gt;&gt;FIR Filter in the NI Signal Generators Help for more information about FIR filter coefficients.
    '''
    '''Note 
    '''The signal generator must not be in the Generating state when you call this function.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Number_of_Coefficients">
    '''Specify the number of coefficients. The NI 5441 requires 95.
    '''
    '''</param>
    '''<param name="Coefficients_Array">
    '''Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, you must provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the Number of Coefficients parameter.
    '''
    '''The coefficients should range between -1.00 and +1.00.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function ConfigureCustomFIRFilterCoefficients(ByVal Channel_Name As String, ByVal Number_of_Coefficients As Integer, ByVal Coefficients_Array() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureCustomFIRFilterCoefficients(Me._handle, Channel_Name, Number_of_Coefficients, Coefficients_Array)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the FIR filter coefficients used by the onboard signal processing block. These coefficients are determined by NI-FGEN and based on the FIR filter type and corresponding attribute (Alpha, Passband, BT) unless you are using the custom filter. If you are using a custom filter, the coefficients returned are those set with the niFgen_ConfigureCustomFIRFilterCoefficients  function coerced to the quantized values used by the device.
    '''
    '''The coefficients will be in the range between -1.00 and +1.00.
    '''
    '''Refer to Devices&gt;&gt;NI 5441&gt;&gt;Theory of Operation&gt;&gt;Onboard Signal Processing&gt;&gt;Components&gt;&gt;FIR Filter in the NI Signal Generators Help for more information about FIR filter coefficients.
    '''
    '''Default Value: None
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to configure the operation mode.
    '''
    '''Defined Value
    '''
    '''0
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Array_Size">
    '''Pass the size of the coefficient array
    '''</param>
    '''<param name="Coefficients_Array">
    '''Specify the array of data that you want to use for the coefficients. The array must have at least as many elements as the value that you specify in the Array Size parameter.
    '''
    '''The coefficients should be in the range between -1.00 and +1.00
    '''
    '''Default Value: None
    '''</param>
    '''<param name="Number_of_Coefficients_Read">
    '''Specify the array of data containing the number of coefficients you want to read.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function GetFIRFilterCoefficients(ByVal Channel_Name As String, ByVal Array_Size As Integer, ByVal Coefficients_Array() As Double, ByVal Number_of_Coefficients_Read() As Long) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetFIRFilterCoefficients(Me._handle, Channel_Name, Array_Size, Coefficients_Array, Number_of_Coefficients_Read)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Initiates signal generation.  If you want to abort signal output, call niFgen_AbortGeneration. Call this function to cause the signal generator to produces a signal again.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function InitiateGeneration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitiateGeneration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Aborts any previously initiated signal generation. If you want to abort signal generation, call this function. Call  niFgen_InitiateGeneration to cause the signal generator to produce a signal again.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function AbortGeneration() As Integer
        Dim pInvokeResult As Integer = PInvoke.AbortGeneration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Sends a command to trigger the signal generator. 
    '''
    '''Note:
    '''
    '''This function can act as an override for an external edge trigger. However, the NI&amp;nbsp;5401/5411/5431 
    '''do not support overriding an external digital edge trigger.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function SendSoftwareTrigger() As Integer
        Dim pInvokeResult As Integer = PInvoke.SendSoftwareTrigger(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the current hardware state of the device and, if the device is in the hardware error state, the current hardware error.  
    '''
    '''NOTE:  Hardware states do not necessarily correspond to NI-FGEN states.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_IDLE:    The device is in the idle state.
    '''NIFGEN_VAL_WAITING_FOR_START_TRIGGER: The device is waiting for   
    '''                                      start trigger.
    '''NIFGEN_VAL_RUNNING: The device is in the running state.
    '''NIFGEN_VAL_DONE:    The generation has completed successfully.
    '''NIFGEN_VAL_HARDWARE_ERROR: There is a hardware error.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="state">
    '''Defined Values
    '''
    '''NIFGEN_VAL_IDLE:    The device is in the idle state.
    '''NIFGEN_VAL_WAITING_FOR_START_TRIGGER: The device is waiting for   
    '''                                      start trigger.
    '''NIFGEN_VAL_RUNNING: The device is in the running state.
    '''NIFGEN_VAL_DONE:    The generation has completed successfully.
    '''NIFGEN_VAL_HARDWARE_ERROR: There is a hardware error.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''</returns>
    Public Function GetHardwareState(ByRef state As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetHardwareState(Me._handle, state)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Waits until the device is done generating or until the maximum time has expired.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="maxTime">
    '''The timeout value (in milliseconds).
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''</returns>
    Public Function WaitUntilDone(ByVal maxTime As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WaitUntilDone(Me._handle, maxTime)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Determines whether the the current generation has completed.  This function sets the done parameter to be true if the session is in the Idle or Committed states.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Done">
    '''True if the generation has completed, false otherwise.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''</returns>
    Public Function IsDone(ByRef Done As Boolean) As Integer
        Dim DoneAsUShort As System.UInt16
        Dim pInvokeResult As Integer = PInvoke.IsDone(Me._handle, DoneAsUShort)
        Done = System.Convert.ToBoolean(DoneAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Resets the instrument and applies initial user specified settings from the logical name that was used to initialize the session.  If the session was created without a logical name, this function is equivalent to niFgen_reset.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ResetWithDefaults() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Performs a hard reset on the device.  Generation is stopped, all routes are released, external bi-directional terminals are tri-stated, FPGAs are reset, hardware is configured to its default state, and all session attributes are reset to their default states.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function ResetDevice() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''The function returns the channel string that is in the channel table at an index you specify.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Index">
    '''A 1-based index into the channel table.
    '''
    '''</param>
    '''<param name="BufferSize">
    '''Size of the buffer for the channel string
    '''</param>
    '''<param name="Channel_Name">
    '''Returns the channel string that is in the channel table at the index you specify.
    '''
    '''Do not modify the contents of the channel string.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetChannelName(ByVal Index As Integer, ByVal BufferSize As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, BufferSize, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function Disable() As Integer
        Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Runs the instrument self-test routine and returns the test result(s). 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Self_Test_Result">
    '''Contains the value returned from the instrument self-test.  Zero means success.  For any other code, refer to the Error and Status Information topic in the NI Signal Sources Help.
    '''
    '''Self-Test Code    Description
    '''---------------------------------------
    '''   0              Passed self-test
    '''   1              Self test failed
    '''
    '''
    '''</param>
    '''<param name="Self_Test_Message">
    '''Returns the self-test response string from the instrument. Refer to the Error and Status Information topic in the NI Signal Sources Help for an explanation of the string contents.
    '''
    '''You must pass a ViChar array with at least 256 bytes.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the revision numbers of the NI-FGEN and instrument firmware.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Instrument_Driver_Revision">
    '''Returns the NI-FGEN software revision numbers in the form of a string.
    '''
    '''You must pass a ViChar array with at least 256 bytes.
    '''</param>
    '''<param name="Firmware_Revision">
    '''Returns the instrument firmware revision numbers in the form of a string.
    '''
    '''You must pass a ViChar array with at least 256 bytes.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the coercion information associated with the IVI session.  This function retrieves and clears the oldest instance in which the NI-FGEN coerced a value you specified to another value.
    '''
    '''If you set the NIFGEN_ATTR_RECORD_COERCIONS attribute to VI_TRUE, the NI-FGEN keeps a list of all coercions it makes on ViInt32 or ViReal64 values you pass to NI-FGEN functions.  You use this function to retrieve information from that list.
    '''
    '''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
    '''
    '''The function returns an empty string in the coercionRecord parameter if no coercion records remain for the session.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the coercionRecord parameter.
    '''
    '''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
    '''
    '''Default Value:  None
    '''
    '''
    '''</param>
    '''<param name="Coercion_Record">
    '''Returns the next coercion record for the IVI session.  If there are no coercion records, the function returns an empty string.
    '''
    '''The buffer must contain at least as many elements as the value you specify with the bufferSize parameter.  If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''This parameter returns an empty string if no coercion records remain for the session.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''        
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Coercion_Record)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Reads an error code and a message from the instrument error queue.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Error_Code">
    '''Returns the error code read from the instrument error queue.
    '''
    '''
    '''</param>
    '''<param name="Error_Message">
    '''Returns the error message string read from the instrument error message queue.
    '''
    '''You must pass a ViChar array with at least 256 bytes.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''          
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function error_query(ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.error_query(Me._handle, Error_Code, Error_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Converts a status code returned by an NI-FGEN function into a user-readable string and returns any error elaborations.   
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''You can pass VI_NULL for this parameter.  Passing VI_NULL is useful when one of the initialize functions fail.
    '''
    '''Default Value:  VI_NULL
    '''
    '''</param>
    '''<param name="Error_Code">
    '''Pass the Status parameter that is returned from any of the NI-FGEN functions.
    '''
    '''Default Value:  0  (VI_SUCCESS)
    '''</param>
    '''<param name="Error_Message">
    '''Returns the user-readable message string that corresponds to the status code you specify.
    '''
    '''You must pass a ViChar array with at least 256 bytes.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message.  To obtain additional information about the error condition, call niFgen_GetError.  To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status    Description
    '''-------------------------------------------------
    '''ERRORS
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources.  The following list contains the ranges of include file status codes that NI-FGEN can return.  
    '''          
    '''Numeric Range (in Hex)   Include Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP Driver Errors
    '''
    '''
    '''</returns>
    Public Function ErrorHandler(ByVal Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.ErrorHandler(Me._handle, Error_Code, Error_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning.  Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. Use this function to retrieve interchangeability warnings.
    '''
    '''NI-FGEN performs interchangeability checking when NIFGEN_ATTR_INTERCHANGE_CHECK is set to VI_TRUE.
    '''
    '''The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session.
    '''
    '''In general, NI-FGEN generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the interchangeWarning parameter.
    '''
    '''If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value. For example, if the value is "123456" and the buffer size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Interchange_Warning">
    '''Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.
    '''
    '''The buffer must contain at least as many elements as the value you specify with the bufferSize parameter. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''This parameter returns an empty string if no interchangeability
    '''warnings remain for the session.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Clears the list of current interchange warnings.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ClearInterchangeWarnings() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
    '''
    '''You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
    '''
    '''This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that niFgen_GetNextInterchangeWarning only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling niFgen_GetNextInterchangeWarning until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call niFgen_ClearInterchangeWarnings.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ResetInterchangeCheck() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Closes an NI-FGEN external calibration session and, if specified, stores the new calibration constants and calibration data, such as time and temperature, in the onboard EEPROM.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Action">
    '''The action to perform upon closing. Valid choices are Abort, which disregards the new calibration constants, and Commit, which stores the new calibration constants on the device.
    '''
    '''Defined Values
    '''
    '''NIFGEN_VAL_EXT_CAL_ABORT - No changes are made to the calibration constants and data in the EEPROM.
    '''
    '''NIFGEN_VAL_EXT_CAL_COMMIT - The new calibration constants and data determined during the external calibration session are stored in the onboard EEPROM.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CloseExtCal(ByVal Action As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CloseExtCal(Me._handle, Action)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Performs a full internal (self-) calibration on the device.  If the calibration is successful, new calibration data and constants are stored in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function SelfCal() As Integer
        Dim pInvokeResult As Integer = PInvoke.SelfCal(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''This function sets up the device to start the analog output calibration.
    '''
    '''The session handle should be the handle returned by niFgen_InitExtCal.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use the niFgen_GetError and niFgen_ClearError functions.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function InitializeAnalogOutputCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeAnalogOutputCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Writes the 16-bit value to the DAC, which could be output as a DC voltage. This function writes to the DAC only when in an external calibration session.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''Pass the channel name for which you want to write the value.
    '''
    '''Default Value: "0"
    '''
    '''</param>
    '''<param name="Value">
    '''The value to write.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function WriteBinary16AnalogStaticValue(ByVal Channel_Name As String, ByVal Value As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteBinary16AnalogStaticValue(Me._handle, Channel_Name, Value)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the pre-amplifier offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. The configuration data as well as the measurements, are passed to this function so that, NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Configuration">
    '''Pre-amp stage configuration.
    '''</param>
    '''<param name="Gain_DAC_Values">
    '''An array of the values programmed to the gain calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Offset_DAC_Values">
    '''An array of the values programmed to the offset calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Measured_Outputs">
    '''An array of the analog output voltages measured during this calibration stage.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustMainPathPreAmpOffset(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Gain_DAC_Values() As Long, ByVal Offset_DAC_Values() As Long, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPreAmpOffset(Me._handle, Channel_Name, Configuration, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the pre-amplifier gain of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Configuration">
    '''Pre-amp stage configuration.
    '''</param>
    '''<param name="Main_DAC_Values">
    '''An array of the values programmed to the main output DAC during this calibration stage.
    '''</param>
    '''<param name="Gain_DAC_Values">
    '''An array of the values programmed to the gain calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Offset_DAC_Values">
    '''An array of the values programmed to the offset calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Measured_Outputs">
    '''An array of the analog output voltages measured during this calibration stage.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustMainPathPreAmpGain(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values() As Long, ByVal Gain_DAC_Values() As Long, ByVal Offset_DAC_Values() As Long, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPreAmpGain(Me._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the post-amplifier gain and offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage.  The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Configuration">
    '''Post-amp stage configuration.
    '''</param>
    '''<param name="Main_DAC_Values">
    '''An array of the values programmed to the gain calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Gain_DAC_Values">
    '''An array of the values programmed to the gain calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Offset_DAC_Values">
    '''An array of the values programmed to the offset calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Measured_Outputs">
    '''An array of the analog output voltages measured during this calibration stage.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustMainPathPostAmpGainAndOffset(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values() As Long, ByVal Gain_DAC_Values() As Long, ByVal Offset_DAC_Values() As Long, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPostAmpGainAndOffset(Me._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the gain of the direct analog path. During external calibration, you can put the device in different configurations; program different gain and main DAC values; and take measurements of the resulting output voltage. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Main_DAC_Values">
    '''An array of the values programmed to the main output DAC during this calibration stage.
    '''</param>
    '''<param name="Gain_DAC_Values">
    '''An array of the values programmed to the gain calibration DAC during this calibration stage.
    '''</param>
    '''<param name="Measured_Outputs">
    '''An array of the analog output voltages measured during this calibration stage.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustDirectPathGain(ByVal Channel_Name As String, ByVal Main_DAC_Values() As Long, ByVal Gain_DAC_Values() As Long, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustDirectPathGain(Me._handle, Channel_Name, Main_DAC_Values, Gain_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to main analog path output impedance.  During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads.  The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Configuration">
    '''Main path output impedance configuration.
    '''</param>
    '''<param name="Load_Impedance">
    '''The impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
    '''</param>
    '''<param name="Measured_Source_Voltage">
    '''The analog output voltage measured across a very high-impedance load.
    '''</param>
    '''<param name="Measured_Voltage_Across_Load">
    '''The analog output voltage measured across the load impedance specified in the loadImpedance parameter.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustMainPathOutputImpedance(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathOutputImpedance(Me._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to direct analog path output impedance. During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads. The configuration data, as well as the measurements, are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Channel_Name">
    '''The name of the channel being calibrated.
    '''
    '''Default Value: "0"
    '''</param>
    '''<param name="Configuration">
    '''Direct path output impedance configuration.
    '''</param>
    '''<param name="Load_Impedance">
    '''The impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
    '''</param>
    '''<param name="Measured_Source_Voltage">
    '''The analog output voltage measured across a very high-impedance load.
    '''</param>
    '''<param name="Measured_Voltage_Across_Load">
    '''The analog output voltage measured across the load impedance specified in the loadImpedance parameter.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustDirectPathOutputImpedance(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustDirectPathOutputImpedance(Me._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''This functions sets up the device to start the VCXO calibration.
    '''
    '''The session handle should be the handle returned by niFgen_InitExtCal.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function InitializeOscillatorFrequencyCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeOscillatorFrequencyCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  The desired and measured frequencies are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Desired_Frequency">
    '''The expected frequency of the output waveform.
    '''</param>
    '''<param name="Measured_Frequency">
    '''The actual (measured) frequency of the output waveform.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustOscillatorFrequency(ByVal Desired_Frequency As Double, ByVal Measured_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustOscillatorFrequency(Me._handle, Desired_Frequency, Measured_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Initializes an external calibration session for calibration ADC calibration.  For the NI 5421/5422/5441, calibration ADC calibration involves characterizing the gain and offset of the onboard calibration ADC.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function InitializeCalADCCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeCalADCCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Calculates calibration constants pertaining to the gain and offset of the on-board calibration ADC.  During external calibration, you can output voltages and measure them both externally and with the calibration ADC.  The measured voltages are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Voltages_Measured_Externally">
    '''An array of analog output voltages measured with an external instrument.
    '''</param>
    '''<param name="Voltages_Measured_With_CalADC">
    '''An array of analog output voltages measured with the onboard calibration ADC.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function CalAdjustCalADC(ByVal Voltages_Measured_Externally() As Double, ByVal Voltages_Measured_With_CalADC() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustCalADC(Me._handle, Voltages_Measured_Externally, Voltages_Measured_With_CalADC)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Takes one or more voltage measurements from the onboard calibration ADC and returns their average value. The signal that the ADC actually measures can be specified using NIFGEN_ATTR_CAL_ADC_INPUT. The ADC has some inherent gain and offset. These values can be determined during an external calibration session and stored in the calibration EEPROM.
    '''
    '''If the returnCalibratedValue parameter is VI_TRUE, NI-FGEN adjusts the value that is returned to account for the gain and offset of the ADC. Otherwise, the raw voltage value reported by the ADC is returned.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Number_of_Reads_to_Average">
    '''Specifies the number of measurements to be taken and averaged to determine the return value.
    '''</param>
    '''<param name="Return_Calibrated_Value">
    '''Specifies whether the voltage returned from the ADC should be adjusted to account for the gain and offset of the ADC.
    '''</param>
    '''<param name="Cal_ADC_Value">
    '''The average of the voltage measurements taken from the onboard calibration ADC.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ReadCalADC(ByVal Number_of_Reads_to_Average As Integer, ByVal Return_Calibrated_Value As Boolean, ByRef Cal_ADC_Value As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ReadCalADC(Me._handle, Number_of_Reads_to_Average, System.Convert.ToUInt16(Return_Calibrated_Value), Cal_ADC_Value)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns whether or not the device supports self-calibration.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Self_Cal_Supported">
    '''VI_TRUE if self-calibration is supported. VI_FALSE otherwise.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetSelfCalSupported(ByRef Self_Cal_Supported As Boolean) As Integer
        Dim Self_Cal_SupportedAsUShort As System.UInt16
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalSupported(Me._handle, Self_Cal_SupportedAsUShort)
        Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the date and time of the last successful self-calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function will return 14 for the hours parameter and 30 for the minutes parameter.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitExtCal.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Year">
    '''The year of the last successful calibration.
    '''</param>
    '''<param name="Month">
    '''The month of the last successful calibration.
    '''</param>
    '''<param name="Day">
    '''The day of the last successful calibration.
    '''</param>
    '''<param name="Hour">
    '''The hour of the last successful calibration.
    '''</param>
    '''<param name="Minute">
    '''The minute of the last successful calibration.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetSelfCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the date and time of the last successful external calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function will return 14 for the hours parameter and 30 for the minutes parameter.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitExtCal.  The handle identifies a particular instrument session.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Year">
    '''The year of the last successful calibration.
    '''</param>
    '''<param name="Month">
    '''The month of the last successful calibration.
    '''</param>
    '''<param name="Day">
    '''The day of the last successful calibration.
    '''</param>
    '''<param name="Hour">
    '''The hour of the last successful calibration.
    '''</param>
    '''<param name="Minute">
    '''The minute of the last successful calibration.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetExtCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the temperature at the last successful self-calibration.  The temperature is returned in degrees Celsius.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Temperature">
    '''The temperature at the last successful calibration.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetSelfCalLastTemp(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalLastTemp(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the temperature at the last successful external calibration.  The temperature is returned in degrees Celsius.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Temperature">
    '''The temperature at the last successful calibration.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetExtCalLastTemp(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastTemp(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the recommended interval between external calibrations in months.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Months">
    '''The recommended interval between external calibrations in months.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetExtCalRecommendedInterval(ByRef Months As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalRecommendedInterval(Me._handle, Months)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Changes the password that is required to initialize an external calibration session.  The password may be up to four characters long.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Old_Password">
    '''The old (current) external calibration password.
    '''</param>
    '''<param name="New_Password">
    '''The new (desired) external calibration password.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ChangeExtCalPassword(ByVal Old_Password As String, ByVal New_Password As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ChangeExtCalPassword(Me._handle, Old_Password, New_Password)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Stores user-defined information in the onboard EEPROM.  Use niFgen_GetCalUserDefinedInfoMaxSize to determine the number of characters that can be stored.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Info">
    '''The information string that should be stored in the EEPROM.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function SetCalUserDefinedInfo(ByVal Info As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Retrieves user-defined information from the onboard EEPROM.  Use niFgen_GetCalUserDefinedInfoMaxSize to determine the number of characters that can be retrieved.  The buffer provided by the user should be the size of the maximum number of characters stored plus one termination character.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Info">
    '''A string into which the user information is copied.  This paramenter must point to a character buffer large enough to hold the information string.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetCalUserDefinedInfo(ByVal Info As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Returns the maximum number of characters (excluding the termination character) of user-defined information that can be stored in the onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value:  None
    '''
    '''</param>
    '''<param name="Info_Size">
    '''The maximum number of characters of user defined info that can be stored in the onboard EEPROM.
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message.  To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function GetCalUserDefinedInfoMaxSize(ByRef Info_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfoMaxSize(Me._handle, Info_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Reads the current onboard temperature of the device. The temperature is returned in degrees Celsius.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle returned from niFgen_init or niFgen_InitExtCal.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Temperature">
    '''Current temperature read from onboard temperature sensors (degrees Celsius).
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function ReadCurrentTemperature(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ReadCurrentTemperature(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Overwrites the current calibration constants with those from the last successful external calibration. This action effectively undoes any self-calibrations performed since the last time an external calibration was performed. This function should be used if a self-calibration produced invalid calibration constants.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_InitExtCal. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<returns>
    '''Reports the status of this operation.
    '''
    '''To obtain a text description of the status code, or if the status code is not shown in the following list, call niFgen_error_message. To obtain additional information about the error condition, use niFgen_GetError and niFgen_ClearError.
    '''
    '''Status Codes
    '''
    '''Status    Description
    '''-------------------------------------------------
    '''       0  No error (the call was successful).
    '''
    '''3FFF0005  The specified termination character was read.
    '''3FFF0006  The specified number of bytes was read.
    '''
    '''3FFC0102  Reset not supported.
    '''
    '''BFFF0000  Miscellaneous or system error occurred.
    '''BFFF000E  Invalid session handle.
    '''BFFF0015  Timeout occurred before operation could complete.
    '''BFFF0034  Violation of raw write protocol occurred.
    '''BFFF0035  Violation of raw read protocol occurred.
    '''BFFF0036  Device reported an output protocol error.
    '''BFFF0037  Device reported an input protocol error.
    '''BFFF0038  Bus error occurred during transfer.
    '''BFFF003A  Invalid setup (attributes are not consistent).
    '''BFFF005F  A "no listeners" condition was detected.
    '''BFFF0060  This interface is not the controller-in-charge.
    '''BFFF0067  Operation is not supported on this session.
    '''
    '''</returns>
    Public Function RestoreLastExtCalConstants() As Integer
        Dim pInvokeResult As Integer = PInvoke.RestoreLastExtCalConstants(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Creates an arbitrary waveform and returns a handle that identifies that waveform. You can pass this handle to niFgen_ConfigureArbWaveform to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with niFgen_CreateArbSequence.
    '''
    '''Notes:
    '''
    '''(1) You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
    '''
    '''(2) You must scale the data between -1.00 and +1.00. Use the Gain parameter to generate different output voltages. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Size">
    '''Pass the size of the arbitrary waveform that you want created.
    '''
    '''The size must meet the following restrictions:
    '''
    '''- The size must be less than or equal to the maximum waveform size that the device allows.
    '''- The size must be greater than or equal to the minimum waveform size that the device allows.
    '''- The size must be an integer multiple of the device waveform quantum.
    '''
    '''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the Waveform Size parameter.
    '''
    '''You must normalize the data points in the array to be between -1.00 and +1.00.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''Returns the handle that identifies the new arbitrary waveform.  You can pass this handle to niFgen_ConfigureArbWaveform to generate the arbitrary waveform. You can pass an array of these handles to niFgen_CreateArbSequence to create an arbitrary sequence.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateArbWaveform(ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateArbWaveform(Me._handle, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    '''<summary>
    '''Creates an arbitrary waveform from binary data and returns a handle that identifies that waveform. You can pass this handle to niFgen_ConfigureArbWaveform to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with niFgen_CreateArbSequence.
    '''
    '''Notes:  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''The session handle that you obtain from niFgen_init or niFgen_InitWithOptions. The handle identifies a particular instrument session.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Size">
    '''Pass the size of the arbitrary waveform that you want created.
    '''
    '''The size must meet the following restrictions:
    '''
    '''- The size must be less than or equal to the maximum waveform size that the instrument allows.
    '''- The size must be greater than or equal to the minimum waveform size the instrument allows.
    '''- The size must be an integer multiple of the instrument waveform quantum.
    '''
    '''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Data_Array">
    '''Specify the array of data that you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in the waveformSize parameter.
    '''
    '''You must normalize the data points in the array to be between -32768 and +32767.
    '''
    '''Default Value: None
    '''
    '''</param>
    '''<param name="Waveform_Handle">
    '''Returns the handle that identifies the new arbitrary waveform.  You can pass this handle to niFgen_ConfigureArbWaveform to generate the arbitrary waveform. You can also pass an array of these handles to niFgen_CreateArbSequence to create an arbitrary sequence.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niFgen_error_message. To obtain additional information about the error condition, call niFgen_GetError. To clear the error information from NI-FGEN, call niFgen_ClearError.
    '''          
    '''The general meaning of the status code is as follows.
    '''
    '''Value                  Meaning
    '''-------------------------------
    '''0                      Success
    '''Positive Values        Warnings
    '''Negative Values        Errors
    '''
    '''NI-FGEN defines the following status codes.
    '''          
    '''Status        Description
    '''-------------------------------------------------
    '''ERRORS
    '''
    '''BFFA4001      Internal Driver Error: DAQ Parameter change
    '''BFFA4002      Internal Driver Error: DAQ Group Control
    '''BFFA4003      Internal Driver Error: DAQ Select Signal
    '''BFFA4004      Internal Driver Error: DAQ Group Setup
    '''BFFA4005      Internal Driver Error: DAQ Configure
    '''BFFA4006      Internal Driver Error: DAQ Init Board
    '''BFFA4007      Internal Driver Error: DAQ Waveform Load
    '''BFFA4008      Internal Driver Error: DAQ Get Attribute
    '''BFFA4009      Invalid Frequency List
    '''BFFA400A      No Frequency Lists Available
    '''BFFA400B      Invalid Frequency List Length
    '''BFFA400C      Internal Driver Error: DAQ Clock Rate
    '''BFFA400D      Invalid Sample Count
    '''BFFA400E      Invalid Marker
    '''BFFA400F      Invalid Frequency
    '''BFFA4010      Invalid Duration
    '''BFFA4011      Internal Driver Error: DAQ Set Clock
    '''BFFA4012      Internal Driver Error: DAQ Device Info
    '''
    '''NI-FGEN also returns errors and warnings defined by other sources. The following list contains the ranges of include file status codes that NI-FGEN can return.
    '''          
    '''Numeric Range (in Hex)   Include  Code Types    
    '''-------------------------------------------------
    '''3FFA2000 to 3FFA3FFF     IviFgen  Warnings
    '''3FFA0000 to 3FFA1FFF     IVI      Warnings
    '''3FFF0000 to 3FFFFFFF     VISA     Warnings
    '''3FFC0000 to 3FFCFFFF     VXIPnP   Driver Warnings
    '''          
    '''BFFA2000 to BFFA3FFF     IviFgen  Errors
    '''BFFA0000 to BFFA1FFF     IVI      Errors
    '''BFFF0000 to BFFFFFFF     VISA     Errors
    '''BFFC0000 to BFFCFFFF     VXIPnP   Driver Errors
    '''
    '''
    '''</returns>
    Public Function CreateBinary16ArbWaveform(ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Short, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateBinary16ArbWaveform(Me._handle, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function

    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        Me.Dispose(True)
        System.GC.SuppressFinalize(Me)
    End Sub

    Private Overloads Sub Dispose(ByVal disposing As Boolean)
        If (Me._disposed = False) Then
            PInvoke.close(Me._handle)
            Me._handle = System.IntPtr.Zero
        End If
        Me._disposed = True
    End Sub

    Protected Overrides Sub Finalize()
        Me.Dispose(False)
    End Sub

    Public Overloads Sub SetInt32(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
    End Sub

    Public Overloads Sub SetInt32(ByVal propertyId As niFgenProperties, ByVal val As Integer)
        Me.SetInt32(propertyId, "", val)
    End Sub

    Public Overloads Function GetInt32(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
        Dim val As Integer
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        Return val
    End Function

    Public Overloads Function GetInt32(ByVal propertyId As niFgenProperties) As Integer
        Return Me.GetInt32(propertyId, "")
    End Function

    Public Overloads Sub SetDouble(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
    End Sub

    Public Overloads Sub SetDouble(ByVal propertyId As niFgenProperties, ByVal val As Double)
        Me.SetDouble(propertyId, "", val)
    End Sub

    Public Overloads Function GetDouble(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Double
        Dim val As Double
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        Return val
    End Function

    Public Overloads Function GetDouble(ByVal propertyId As niFgenProperties) As Double
        Return Me.GetDouble(propertyId, "")
    End Function

    Public Overloads Sub SetBoolean(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), System.Convert.ToUInt16(val)))
    End Sub

    Public Overloads Sub SetBoolean(ByVal propertyId As niFgenProperties, ByVal val As Boolean)
        Me.SetBoolean(propertyId, "", val)
    End Sub

    Public Overloads Function GetBoolean(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
        Dim val As System.UInt16
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        Return System.Convert.ToBoolean(val)
    End Function

    Public Overloads Function GetBoolean(ByVal propertyId As niFgenProperties) As Boolean
        Return Me.GetBoolean(propertyId, "")
    End Function

    Public Overloads Sub SetString(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
    End Sub

    Public Overloads Sub SetString(ByVal propertyId As niFgenProperties, ByVal val As String)
        Me.SetString(propertyId, "", val)
    End Sub

    Public Overloads Function GetString(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As String
        Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
        Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), 512, newVal)
        If (size < 0) Then
            PInvoke.ThrowError(Me._handle, size)
        Else
            If (size > 0) Then
                newVal.Capacity = size
                PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), size, newVal))
            End If
        End If
        Return newVal.ToString
    End Function

    Public Overloads Function GetString(ByVal propertyId As niFgenProperties) As String
        Return Me.GetString(propertyId, "")
    End Function

    Public Overloads Sub SetSession(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As System.IntPtr)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViSession(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
    End Sub

    Public Overloads Sub SetSession(ByVal propertyId As niFgenProperties, ByVal val As System.IntPtr)
        Me.SetSession(propertyId, "", val)
    End Sub

    Public Overloads Function GetSession(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As System.IntPtr
        Dim val As System.IntPtr
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViSession(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        Return val
    End Function

    Public Overloads Function GetSession(ByVal propertyId As niFgenProperties) As System.IntPtr
        Return Me.GetSession(propertyId, "")
    End Function

    Private Class PInvoke

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_init", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function init(ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByRef Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitWithOptions(ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitExtCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitExtCal(ByVal Resource_Name As String, ByVal Password As String, ByRef Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_Commit", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Commit(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_reset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOperationMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOperationMode(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Operation_Mode As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputMode(ByVal Instrument_Handle As System.IntPtr, ByVal Output_Mode As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputEnabled", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputEnabled(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Enabled As System.UInt16) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputImpedance(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Impedance As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_EnableAnalogFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableAnalogFilter(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Filter_Correction_Frequency As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_DisableAnalogFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableAnalogFilter(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_EnableDigitalFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableDigitalFilter(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_DisableDigitalFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableDigitalFilter(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_EnableDigitalPatterning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableDigitalPatterning(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_DisableDigitalPatterning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableDigitalPatterning(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureStandardWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Frequency As Double, ByVal Start_Phase As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_DefineUserStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DefineUserStandardWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearUserStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearUserStandardWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureFrequency(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Frequency As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureAmplitude", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureAmplitude(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Amplitude As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateFreqList(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform As Integer, ByVal Frequency_List_Length As Integer, ByVal Frequency_Array As Double(), ByVal Duration_Array As Double(), ByRef Frequency_List_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureFreqList(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Frequency_List_Handle As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Start_Phase As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearFreqList(ByVal Instrument_Handle As System.IntPtr, ByVal Frequency_List_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_QueryFreqListCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryFreqListCapabilities(ByVal Instrument_Handle As System.IntPtr, ByRef Maximum_Number_Of_Freq_Lists As Integer, ByRef Minimum_Frequency_List_Length As Integer, ByRef Maximum_Frequency_List_Length As Integer, ByRef Minimum_Frequency_List_Duration As Double, ByRef Maximum_Frequency_List_Duration As Double, ByRef Frequency_List_Duration_Quantum As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureGain(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Gain As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSampleRate", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSampleRate(ByVal Instrument_Handle As System.IntPtr, ByVal Sample_Rate As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_QueryArbWfmCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryArbWfmCapabilities(ByVal Instrument_Handle As System.IntPtr, ByRef Maximum_Number_of_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Minimum_Waveform_Size As Integer, ByRef Maximum_Waveform_Size As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double(), ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformI16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Short(), ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformComplexF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformComplexF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Waveform_Data_Array As niFgenComplexF64, ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileI16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileHWS", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileHWS(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Use_Rate_From_Waveform As System.UInt16, ByVal Use_Gain___Offset_From_Waveform As System.UInt16, ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_QueryArbSeqCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryArbSeqCapabilities(ByVal Instrument_Handle As System.IntPtr, ByRef Maximum_Number_of_Sequences As Integer, ByRef Minimum_Sequence_Length As Integer, ByRef Maximum_Sequence_Length As Integer, ByRef Maximum_Loop_Count As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateArbSequence(ByVal Instrument_Handle As System.IntPtr, ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array As Long(), ByVal Loop_Counts_Array As Long(), ByRef Sequence_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateAdvancedArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateAdvancedArbSequence(ByVal Instrument_Handle As System.IntPtr, ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array As Long(), ByVal Loop_Counts_Array As Long(), ByVal Sample_Counts_Array As Long(), ByVal Marker_Location_Array As Long(), ByVal Coerced_Markers_Array As Long(), ByRef Sequence_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureArbSequence(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Sequence_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbSequence(ByVal Instrument_Handle As System.IntPtr, ByVal Sequence_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearArbMemory", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbMemory(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_AllocateWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AllocateWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetWaveformNextWritePosition", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetWaveformNextWritePosition(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_WriteWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_WriteWaveformComplexF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteWaveformComplexF64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Data As niFgenComplexF64, ByVal Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_WriteBinary16Waveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteBinary16Waveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As Short()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureRefClockSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureRefClockSource(ByVal Instrument_Handle As System.IntPtr, ByVal Reference_Clock_Source As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureRefClockFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureRefClockFrequency(ByVal Instrument_Handle As System.IntPtr, ByVal Reference_Clock_Frequency As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureClockMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureClockMode(ByVal Instrument_Handle As System.IntPtr, ByVal Clock_Mode As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureUpdateClockSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureUpdateClockSource(ByVal Instrument_Handle As System.IntPtr, ByVal Update_Clock_Source As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_AdjustSampleClockRelativeDelay", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AdjustSampleClockRelativeDelay(ByVal Instrument_Handle As System.IntPtr, ByVal Adjustment_Time As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureTriggerSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureTriggerSource(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Trigger_Source As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureTriggerMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureTriggerMode(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Trigger_Mode As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_RouteSignalOut", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RouteSignalOut(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Route_Signal_From As Integer, ByVal Route_Signal_To As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSynchronization", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSynchronization(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Synchronization_Source As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ConfigureCustomFIRFilterCoefficients", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureCustomFIRFilterCoefficients(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Coefficients As Integer, ByVal Coefficients_Array As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetFIRFilterCoefficients", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetFIRFilterCoefficients(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Array_Size As Integer, ByVal Coefficients_Array As Double(), ByVal Number_of_Coefficients_Read As Long()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitiateGeneration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitiateGeneration(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_AbortGeneration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AbortGeneration(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SendSoftwareTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SendSoftwareTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetHardwareState", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetHardwareState(ByVal Instrument_Handle As System.IntPtr, ByRef state As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_WaitUntilDone", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WaitUntilDone(ByVal Instrument_Handle As System.IntPtr, ByVal maxTime As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_IsDone", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function IsDone(ByVal Instrument_Handle As System.IntPtr, ByRef Done As System.UInt16) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ResetWithDefaults", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetWithDefaults(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetDevice(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetChannelName", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetChannelName(ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal BufferSize As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_Disable", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Disable(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_self_test", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_revision_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function revision_query(ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetNextCoercionRecord", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextCoercionRecord(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_error_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_query(ByVal Instrument_Handle As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ErrorHandler", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ErrorHandler(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetNextInterchangeWarning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextInterchangeWarning(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ClearInterchangeWarnings", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearInterchangeWarnings(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ResetInterchangeCheck", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetInterchangeCheck(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CloseExtCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CloseExtCal(ByVal Instrument_Handle As System.IntPtr, ByVal Action As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SelfCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SelfCal(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitializeAnalogOutputCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeAnalogOutputCalibration(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_WriteBinary16AnalogStaticValue", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteBinary16AnalogStaticValue(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Value As Short) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPreAmpOffset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPreAmpOffset(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Gain_DAC_Values As Long(), ByVal Offset_DAC_Values As Long(), ByVal Measured_Outputs As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPreAmpGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPreAmpGain(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values As Long(), ByVal Gain_DAC_Values As Long(), ByVal Offset_DAC_Values As Long(), ByVal Measured_Outputs As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPostAmpGainAndOffset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPostAmpGainAndOffset(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values As Long(), ByVal Gain_DAC_Values As Long(), ByVal Offset_DAC_Values As Long(), ByVal Measured_Outputs As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustDirectPathGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustDirectPathGain(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Main_DAC_Values As Long(), ByVal Gain_DAC_Values As Long(), ByVal Measured_Outputs As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathOutputImpedance(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustDirectPathOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustDirectPathOutputImpedance(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitializeOscillatorFrequencyCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeOscillatorFrequencyCalibration(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustOscillatorFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustOscillatorFrequency(ByVal Instrument_Handle As System.IntPtr, ByVal Desired_Frequency As Double, ByVal Measured_Frequency As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_InitializeCalADCCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeCalADCCalibration(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustCalADC", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustCalADC(ByVal Instrument_Handle As System.IntPtr, ByVal Voltages_Measured_Externally As Double(), ByVal Voltages_Measured_With_CalADC As Double()) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ReadCalADC", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadCalADC(ByVal Instrument_Handle As System.IntPtr, ByVal Number_of_Reads_to_Average As Integer, ByVal Return_Calibrated_Value As System.UInt16, ByRef Cal_ADC_Value As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalSupported", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalSupported(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Cal_Supported As System.UInt16) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalLastDateAndTime", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalLastDateAndTime(ByVal Instrument_Handle As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalLastDateAndTime", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalLastDateAndTime(ByVal Instrument_Handle As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalLastTemp", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalLastTemp(ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalLastTemp", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalLastTemp(ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalRecommendedInterval", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalRecommendedInterval(ByVal Instrument_Handle As System.IntPtr, ByRef Months As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ChangeExtCalPassword", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ChangeExtCalPassword(ByVal Instrument_Handle As System.IntPtr, ByVal Old_Password As String, ByVal New_Password As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetCalUserDefinedInfo(ByVal Instrument_Handle As System.IntPtr, ByVal Info As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetCalUserDefinedInfo(ByVal Instrument_Handle As System.IntPtr, ByVal Info As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetCalUserDefinedInfoMaxSize", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetCalUserDefinedInfoMaxSize(ByVal Instrument_Handle As System.IntPtr, ByRef Info_Size As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_ReadCurrentTemperature", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadCurrentTemperature(ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_RestoreLastExtCalConstants", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RestoreLastExtCalConstants(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double(), ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_CreateBinary16ArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateBinary16ArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Short(), ByRef Waveform_Handle As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_close", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_error_message", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Array_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.UInt16) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.UInt16) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
        End Function

        <DllImport("niFgen_32.dll", EntryPoint:="niFgen_GetError", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Description_Buffer_Size As Integer, ByVal Error_Description As System.Text.StringBuilder) As Integer
        End Function

        Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
            If (status < 0) Then
                PInvoke.ThrowError(handle, status)
            End If
            Return status
        End Function

        Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
            Dim status As Integer
            Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
            Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
            If (size >= 0) Then
                msg.Capacity = size
                PInvoke.GetError(handle, status, size, msg)
            End If
            Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
        End Function
    End Class
End Class

Public Class niFgenConstants
    
    Public Const CalConfigMainPathFilterOff6db As Integer = 2
    
    Public Const CalConfigMainPathHighGain0db75ohms As Integer = 9
    
    Public Const CalConfigMainPathLowGain0db75ohms As Integer = 1
    
    Public Const CalConfigMainPathLowGain36db75ohms As Integer = 7
    
    Public Const RefIn As Integer = 1200
    
    Public Const RefClockExternal As Integer = 1
    
    Public Const WfmRampDown As Integer = 5
    
    Public Const ClockOut As Integer = 1009
    
    Public Const None As Integer = 1000
    
    Public Const External As Integer = 1
    
    Public Const UpdateClock As Integer = 1017
    
    Public Const CalConfigMainPathHighGain24db75ohms As Integer = 13
    
    Public Const RefOut As Integer = 1008
    
    Public Const CalConfigMainPathLowGain24db50ohms As Integer = 4
    
    Public Const WaveformPositionStart As Integer = 0
    
    Public Const CalConfigMainPathLowGain0db50ohms As Integer = 0
    
    Public Const CalConfigMainPathFilterOn3db As Integer = 6
    
    Public Const OutStartTrigger As Integer = 1004
    
    Public Const CalConfigMainPathLowGain12db As Integer = 1
    
    Public Const PllRefSource As Integer = 1003
    
    Public Const CalConfigMainPathLowGain36db50ohms As Integer = 6
    
    Public Const CalConfigDirectPath75ohms As Integer = 1
    
    Public Const Continuous As Integer = 2
    
    Public Const WfmSquare As Integer = 2
    
    Public Const CalConfigMainPathFilterOn12db As Integer = 9
    
    Public Const CalConfigMainPathLowGain12db50ohms As Integer = 2
    
    Public Const RefClockTtl7 As Integer = 118
    
    Public Const CalConfigMainPathLowGain36db As Integer = 3
    
    Public Const OperateContinuous As Integer = 0
    
    Public Const CalConfigMainPathHighGain0db50ohms As Integer = 8
    
    Public Const CalConfigMainPathFilterOn0db As Integer = 5
    
    Public Const WfmTriangle As Integer = 3
    
    Public Const CalConfigMainPathLowGain24db75ohms As Integer = 5
    
    Public Const OutputFunc As Integer = 0
    
    Public Const DivideDown As Integer = 1
    
    Public Const Synchronization As Integer = 1007
    
    Public Const Ttl3 As Integer = 114
    
    Public Const CalConfigMainPathLowGain0db As Integer = 0
    
    Public Const CalConfigMainPathFilterOff0db As Integer = 0
    
    Public Const Stepped As Integer = 3
    
    Public Const RefClockRtsiClock As Integer = 101
    
    Public Const ExtCalAbort As Integer = 0
    
    Public Const OutputSeq As Integer = 2
    
    Public Const PxiClk10 As Integer = 1201
    
    Public Const CalConfigMainPathFilterOn6db As Integer = 7
    
    Public Const Burst As Integer = 4
    
    Public Const CalConfigMainPathHighGain36db75ohms As Integer = 15
    
    Public Const Ttl5 As Integer = 116
    
    Public Const Ttl0 As Integer = 111
    
    Public Const Ttl1 As Integer = 112
    
    Public Const Ttl2 As Integer = 113
    
    Public Const OnboardReferenceClock As Integer = 1019
    
    Public Const Ttl4 As Integer = 115
    
    Public Const WfmRampUp As Integer = 4
    
    Public Const Ttl6 As Integer = 117
    
    Public Const Ttl7 As Integer = 118
    
    Public Const ClkIn As Integer = 1202
    
    Public Const CalConfigMainPathHighGain12db75ohms As Integer = 11
    
    Public Const CalConfigMainPathHighGain12db As Integer = 5
    
    Public Const Automatic As Integer = 2
    
    Public Const CalConfigDirectPath50ohms As Integer = 0
    
    Public Const CalConfigMainPathHighGain0db As Integer = 4
    
    Public Const WfmUser As Integer = 102
    
    Public Const HighResolution As Integer = 0
    
    Public Const Pfi0 As Integer = 1011
    
    Public Const Rtsi7 As Integer = 1010
    
    Public Const Pfi2 As Integer = 1013
    
    Public Const Rtsi5 As Integer = 146
    
    Public Const Rtsi4 As Integer = 145
    
    Public Const Rtsi3 As Integer = 144
    
    Public Const Rtsi2 As Integer = 143
    
    Public Const Rtsi1 As Integer = 142
    
    Public Const Rtsi0 As Integer = 141
    
    Public Const OutputFreqList As Integer = 101
    
    Public Const [Single] As Integer = 1
    
    Public Const BoardClock As Integer = 1006
    
    Public Const CalConfigMainPathFilterOn9db As Integer = 8
    
    Public Const CalConfigMainPathFilterOff12db As Integer = 4
    
    Public Const CalConfigMainPathHighGain24db As Integer = 6
    
    Public Const Pfi1 As Integer = 1012
    
    Public Const CalConfigMainPathHighGain36db As Integer = 7
    
    Public Const OutputArb As Integer = 1
    
    Public Const WaveformPositionCurrent As Integer = 1
    
    Public Const ExtCalCommit As Integer = 1
    
    Public Const RefClockInternal As Integer = 0
    
    Public Const CalConfigMainPathHighGain36db50ohms As Integer = 14
    
    Public Const SoftwareTrig As Integer = 2
    
    Public Const Marker As Integer = 1001
    
    Public Const CalConfigMainPathFilterOff3db As Integer = 1
    
    Public Const LittleEndian As Integer = 0
    
    Public Const CalConfigMainPathHighGain24db50ohms As Integer = 12
    
    Public Const CalConfigMainPathFilterOff9db As Integer = 3
    
    Public Const Pfi3 As Integer = 1014
    
    Public Const CalConfigMainPathLowGain12db75ohms As Integer = 3
    
    Public Const Immediate As Integer = 0
    
    Public Const WfmSine As Integer = 1
    
    Public Const PxiStar As Integer = 131
    
    Public Const Internal As Integer = 0
    
    Public Const Rtsi6 As Integer = 147
    
    Public Const WfmDc As Integer = 6
    
    Public Const CalConfigMainPathLowGain24db As Integer = 2
    
    Public Const DdcClkIn As Integer = 1203
    
    Public Const BigEndian As Integer = 1
    
    Public Const SyncOut As Integer = 1002
    
    Public Const CalConfigMainPathHighGain12db50ohms As Integer = 10
End Class

<StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)> _
Public Structure niFgenComplexF64
    Public Real As Double
    Public Imaginary As Double
End Structure

Public Enum niFgenProperties

    '''<summary>
    '''System.Boolean
    '''</summary>
    RangeCheck = 1050002

    '''<summary>
    '''System.Boolean
    '''</summary>
    QueryInstrumentStatus = 1050003

    '''<summary>
    '''System.Boolean
    '''</summary>
    Cache = 1050004

    '''<summary>
    '''System.Boolean
    '''</summary>
    Simulate = 1050005

    '''<summary>
    '''System.Boolean
    '''</summary>
    RecordCoercions = 1050006

    '''<summary>
    '''System.Boolean
    '''</summary>
    InterchangeCheck = 1050021

    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverDescription = 1050514

    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverVendor = 1050513

    '''<summary>
    '''System.Int32
    '''</summary>
    SpecificDriverClassSpecMajorVersion = 1050515

    '''<summary>
    '''System.Int32
    '''</summary>
    SpecificDriverClassSpecMinorVersion = 1050516

    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverPrefix = 1050302

    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverRevision = 1050551

    '''<summary>
    '''System.Int32
    '''</summary>
    ChannelCount = 1050203

    '''<summary>
    '''System.String
    '''</summary>
    SupportedInstrumentModels = 1050327

    '''<summary>
    '''System.String
    '''</summary>
    GroupCapabilities = 1050401

    '''<summary>
    '''System.String
    '''</summary>
    InstrumentManufacturer = 1050511

    '''<summary>
    '''System.String
    '''</summary>
    InstrumentModel = 1050512

    '''<summary>
    '''System.String
    '''</summary>
    InstrumentFirmwareRevision = 1050510

    '''<summary>
    '''System.String
    '''</summary>
    LogicalName = 1050305

    '''<summary>
    '''System.Int32
    '''</summary>
    OperationMode = 1250005

    '''<summary>
    '''System.Int32
    '''</summary>
    OutputMode = 1250001

    '''<summary>
    '''System.Int32
    '''</summary>
    RefClockSource = 1250002

    '''<summary>
    '''System.Boolean
    '''</summary>
    OutputEnabled = 1250003

    '''<summary>
    '''System.Double
    '''</summary>
    OutputImpedance = 1250004

    '''<summary>
    '''System.Int32
    '''</summary>
    FuncWaveform = 1250101

    '''<summary>
    '''System.Double
    '''</summary>
    FuncAmplitude = 1250102

    '''<summary>
    '''System.Double
    '''</summary>
    FuncDcOffset = 1250103

    '''<summary>
    '''System.Double
    '''</summary>
    FuncFrequency = 1250104

    '''<summary>
    '''System.Double
    '''</summary>
    FuncStartPhase = 1250105

    '''<summary>
    '''System.Double
    '''</summary>
    FuncDutyCycleHigh = 1250106

    '''<summary>
    '''System.Int32
    '''</summary>
    FuncBufferSize = 1150238

    '''<summary>
    '''System.Int32
    '''</summary>
    FuncMaxBufferSize = 1150239

    '''<summary>
    '''System.Int32
    '''</summary>
    FreqListHandle = 1150208

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxNumFreqLists = 1150209

    '''<summary>
    '''System.Int32
    '''</summary>
    MinFreqListLength = 1150210

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxFreqListLength = 1150211

    '''<summary>
    '''System.Double
    '''</summary>
    MinFreqListDuration = 1150212

    '''<summary>
    '''System.Double
    '''</summary>
    MaxFreqListDuration = 1150213

    '''<summary>
    '''System.Double
    '''</summary>
    FreqListDurationQuantum = 1150214

    '''<summary>
    '''System.Int32
    '''</summary>
    ArbWaveformHandle = 1250201

    '''<summary>
    '''System.Double
    '''</summary>
    ArbGain = 1250202

    '''<summary>
    '''System.Double
    '''</summary>
    ArbOffset = 1250203

    '''<summary>
    '''System.Double
    '''</summary>
    ArbSampleRate = 1250204

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxNumWaveforms = 1250205

    '''<summary>
    '''System.Int32
    '''</summary>
    WaveformQuantum = 1250206

    '''<summary>
    '''System.Int32
    '''</summary>
    MinWaveformSize = 1250207

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxWaveformSize = 1250208

    '''<summary>
    '''System.Int32
    '''</summary>
    DataTransferBlockSize = 1150241

    '''<summary>
    '''System.Int32
    '''</summary>
    FileTransferBlockSize = 1150240

    '''<summary>
    '''System.Boolean
    '''</summary>
    DirectDmaEnabled = 1150244

    '''<summary>
    '''System.Int32
    '''</summary>
    DirectDmaWindowAddress = 1150274

    '''<summary>
    '''System.Int32
    '''</summary>
    DirectDmaWindowSize = 1150245

    '''<summary>
    '''System.Boolean
    '''</summary>
    OspCicFilterEnabled = 1150257

    '''<summary>
    '''System.Double
    '''</summary>
    OspCicFilterGain = 1150263

    '''<summary>
    '''System.Double
    '''</summary>
    OspCicFilterInterpolation = 1150258

    '''<summary>
    '''System.Boolean
    '''</summary>
    OspFirFilterEnabled = 1150255

    '''<summary>
    '''System.Double
    '''</summary>
    OspFirFilterInterpolation = 1150256

    '''<summary>
    '''System.Int32
    '''</summary>
    OspOverflowErrorReporting = 1150268

    '''<summary>
    '''System.Int32
    '''</summary>
    OspOverflowStatus = 1150269

    '''<summary>
    '''System.Boolean
    '''</summary>
    OspCarrierEnabled = 1150249

    '''<summary>
    '''System.Double
    '''</summary>
    OspCarrierFrequency = 1150250

    '''<summary>
    '''System.Int32
    '''</summary>
    OspDataProcessingMode = 1150247

    '''<summary>
    '''System.Int32
    '''</summary>
    OspFirFilterType = 1150253

    '''<summary>
    '''System.Double
    '''</summary>
    OspFirFilterFlatPassband = 1150261

    '''<summary>
    '''System.Double
    '''</summary>
    OspFirFilterGaussianBt = 1150262

    '''<summary>
    '''System.Double
    '''</summary>
    OspFirFilterRaisedCosineAlpha = 1150260

    '''<summary>
    '''System.Double
    '''</summary>
    OspFirFilterRootRaisedCosineAlpha = 1150259

    '''<summary>
    '''System.Boolean
    '''</summary>
    OspEnabled = 1150246

    '''<summary>
    '''System.Double
    '''</summary>
    OspPreFilterGainI = 1150264

    '''<summary>
    '''System.Double
    '''</summary>
    OspPreFilterGainQ = 1150265

    '''<summary>
    '''System.Double
    '''</summary>
    OspPreFilterOffsetI = 1150266

    '''<summary>
    '''System.Double
    '''</summary>
    OspPreFilterOffsetQ = 1150267

    '''<summary>
    '''System.Double
    '''</summary>
    OspCarrierPhaseI = 1150251

    '''<summary>
    '''System.Double
    '''</summary>
    OspCarrierPhaseQ = 1150252

    '''<summary>
    '''System.Double
    '''</summary>
    OspIqRate = 1150248

    '''<summary>
    '''System.Int32
    '''</summary>
    ArbSequenceHandle = 1250211

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxNumSequences = 1250212

    '''<summary>
    '''System.Int32
    '''</summary>
    MinSequenceLength = 1250213

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxSequenceLength = 1250214

    '''<summary>
    '''System.Int32
    '''</summary>
    MaxLoopCount = 1250215

    '''<summary>
    '''System.Int32
    '''</summary>
    TriggerSource = 1250302

    '''<summary>
    '''System.Int32
    '''</summary>
    TriggerMode = 1150108

    '''<summary>
    '''System.Int32
    '''</summary>
    Synchronization = 1150111

    '''<summary>
    '''System.Double
    '''</summary>
    LoadImpedance = 1150220

    '''<summary>
    '''System.Int32
    '''</summary>
    AnalogPath = 1150222

    '''<summary>
    '''System.Boolean
    '''</summary>
    AnalogFilterEnabled = 1150103

    '''<summary>
    '''System.Double
    '''</summary>
    FilterCorrectionFrequency = 1150104

    '''<summary>
    '''System.Boolean
    '''</summary>
    DigitalFilterEnabled = 1150102

    '''<summary>
    '''System.Boolean
    '''</summary>
    DigitalPatternEnabled = 1150101

    '''<summary>
    '''System.Int32
    '''</summary>
    DigitalFilterInterpolationFactor = 1150218

    '''<summary>
    '''System.Double
    '''</summary>
    DigitalGain = 1150254

    '''<summary>
    '''System.Double
    '''</summary>
    SyncDutyCycleHigh = 1150105

    '''<summary>
    '''System.Int32
    '''</summary>
    AnalogDataMask = 1150234

    '''<summary>
    '''System.Int32
    '''</summary>
    AnalogStaticValue = 1150235

    '''<summary>
    '''System.Int32
    '''</summary>
    DigitalDataMask = 1150236

    '''<summary>
    '''System.Int32
    '''</summary>
    DigitalStaticValue = 1150237

    '''<summary>
    '''System.Int32
    '''</summary>
    ClockMode = 1150110

    '''<summary>
    '''System.Int32
    '''</summary>
    UpdateClockSource = 1150106

    '''<summary>
    '''System.Double
    '''</summary>
    RefClockFrequency = 1150107

    '''<summary>
    '''System.Double
    '''</summary>
    ActualArbSampleRate = 1150109

    '''<summary>
    '''System.Double
    '''</summary>
    SampleClockAbsoluteDelay = 1150231

    '''<summary>
    '''System.Int32
    '''</summary>
    ExportedSampleClockDivisor = 1150219

    '''<summary>
    '''System.Int32
    '''</summary>
    ExportedSampleClockTimebaseDivisor = 1150230

    '''<summary>
    '''System.Int32
    '''</summary>
    BusType = 1150215

    '''<summary>
    '''System.Int32
    '''</summary>
    VideoWaveformType = 1150216

    '''<summary>
    '''System.Int32
    '''</summary>
    MemorySize = 1150242

    '''<summary>
    '''System.String
    '''</summary>
    SerialNumber = 1150243

    '''<summary>
    '''System.Int32
    '''</summary>
    DaqmxTask = 1150221

    '''<summary>
    '''System.Int32
    '''</summary>
    OscillatorPhaseDacValue = 1150232

    '''<summary>
    '''System.Int32
    '''</summary>
    ExternalClockDelayBinaryValue = 1150233

    '''<summary>
    '''System.Int32
    '''</summary>
    GainDacValue = 1150223

    '''<summary>
    '''System.Int32
    '''</summary>
    OffsetDacValue = 1150224

    '''<summary>
    '''System.Int32
    '''</summary>
    OscillatorFreqDacValue = 1150225

    '''<summary>
    '''System.Int32
    '''</summary>
    CalAdcInput = 1150227

    '''<summary>
    '''System.Double
    '''</summary>
    PreAmplifierAttenuation = 1150228

    '''<summary>
    '''System.Double
    '''</summary>
    PostAmplifierAttenuation = 1150229

    '''<summary>
    '''System.Int32
    '''</summary>
    CycleCount = 1250350

    '''<summary>
    '''System.IntPtr
    '''</summary>
    IoSession = 1050322

    '''<summary>
    '''System.Int32
    '''</summary>
    PrimaryError = 1050101

    '''<summary>
    '''System.Int32
    '''</summary>
    SecondaryError = 1050102

    '''<summary>
    '''System.String
    '''</summary>
    ErrorElaboration = 1050103

    '''<summary>
    '''System.Int32
    '''</summary>
    NumChannels = 1050203
End Enum
End Namespace
